---
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by gw.
--- DateTime: 2021/5/13 10:25
---
GW_EmbattleWindow = GW_EmbattleWindow or BaseClass(BaseView)

local controller = HeroController:getInstance()
local elfin_controller = ElfinController:getInstance()
local model = controller:getModel()

local string_format = string.format
local table_sort = table.sort
local table_insert = table.insert
local table_remove = table.remove

function GW_EmbattleWindow:__init()
    self.ctrl = GW_EmbattleController:getInstance()
    self.is_full_screen = true
    self.layout_name = "gw_embattle/gw_embattle_window"

    self.res_list = {
        { path = PathTool.getPlistImgForDownLoad("gw_embattle", "gw_embattle"), type = ResourcesType.plist},
        { path = PathTool.getPlistImgForDownLoad("gw_embattle","1_bg_buzhen", true), type = ResourcesType.single },
        { path = PathTool.getPlistImgForDownLoad("gw_embattle","2_bg_gezi", false), type = ResourcesType.single },
    }


    --英雄对象
    self.hero_item_list = {}
    --英雄对象位置的矩形区域
    self.pos_rect_list = {}
    --9个位置
    self.nine_position = {
        [1] = cc.p(946, 283),
        [2] = cc.p(927, 412),
        [3] = cc.p(914, 505),
        [4] = cc.p(641, 283),
        [5] = cc.p(661, 412),
        [6] = cc.p(680, 505),
        [7] = cc.p(341, 283),
        [8] = cc.p(209, 412),
        [9] = cc.p(436, 505),
    }
    --[[阵型位置
    9   6   3   3   6   9
    8   5   2   2   5   8
    7   4   1   1   4   7
    ]]
    --移动的hero_item对象
    self.move_hero_item = nil

    self.six_hero_vo = {}


    self.formation_choose_name_list = {[1]=UI_TI18N(32001),[2]=UI_TI18N(32002),[3]=UI_TI18N(32029)}
    self.formation_choose_type_list = {[1]=PartnerConst.Fun_Form.Drama,[2]=PartnerConst.Fun_Form.Arena,[3]=PartnerConst.Fun_Form.ArenaChampion}
end

--@fun_form_type 布阵队伍类型 PartnerConst.Fun_Form
--@show_type 出战界面显示类型 1 出战 2 保存布阵 参考 HeroConst.FormShowType
function GW_EmbattleWindow:openRootWnd(fun_form_type, setting, show_type)
    --Debug.log("GW_EmbattleWindow:openRootWnd(fun_form_type, setting, show_type)")
    Debug.info(setting)
    self.is_init_hero = true

    self.fun_form_type = fun_form_type or PartnerConst.Fun_Form.Drama
    self.show_type = show_type or HeroConst.FormShowType.eFormFight
    self.setting = setting or {}
    self.first_sort = nil

    self:setShowTypeUI()
    self:updateFormationChangeBtnStatus()

    local camp_lsit = {}
    self.gw_camp_type_limit = nil
    --初始化英雄列表
    if self.fun_form_type == PartnerConst.Fun_Form.EndLessWater then--新版无尽需要处理特殊选中和灰化不可点击阵营
        self.gw_camp_type_limit = {HeroConst.CampType.eWater}
        self:onClickBtnShowByIndex(HeroConst.CampType.eWater)
        camp_lsit = {0,HeroConst.CampType.eFire,HeroConst.CampType.eWind,HeroConst.CampType.eSoil,HeroConst.CampType.eLight,HeroConst.CampType.eDark}
    elseif self.fun_form_type == PartnerConst.Fun_Form.EndLessFire then
        self.gw_camp_type_limit = {HeroConst.CampType.eFire}
        self:onClickBtnShowByIndex(HeroConst.CampType.eFire)
        camp_lsit = {0,HeroConst.CampType.eWater,HeroConst.CampType.eWind,HeroConst.CampType.eSoil,HeroConst.CampType.eLight,HeroConst.CampType.eDark}
    elseif self.fun_form_type == PartnerConst.Fun_Form.EndLessWind then
        self.gw_camp_type_limit = {HeroConst.CampType.eWind}
        self:onClickBtnShowByIndex(HeroConst.CampType.eWind)
        camp_lsit = {0,HeroConst.CampType.eWater,HeroConst.CampType.eFire,HeroConst.CampType.eSoil,HeroConst.CampType.eLight,HeroConst.CampType.eDark}
    elseif self.fun_form_type == PartnerConst.Fun_Form.EndLessSoil then
        self.gw_camp_type_limit = {HeroConst.CampType.eSoil}
        self:onClickBtnShowByIndex(HeroConst.CampType.eSoil)
        camp_lsit = {0,HeroConst.CampType.eWater,HeroConst.CampType.eFire,HeroConst.CampType.eWind,HeroConst.CampType.eLight,HeroConst.CampType.eDark}
    elseif self.fun_form_type == PartnerConst.Fun_Form.EndLessLightDark then
        self.gw_camp_type_limit = {HeroConst.CampType.eLight,HeroConst.CampType.eDark}
        self:onClickBtnShowByIndex(HeroConst.CampType.eLight)
        camp_lsit = {0,HeroConst.CampType.eWater,HeroConst.CampType.eFire,HeroConst.CampType.eWind,HeroConst.CampType.eSoil}
    else
        self:onClickBtnShowByIndex(0)
    end

    self:setCampBtnUnEnabled(camp_lsit)

    --先初始化当前编辑阵容类型
    self:updateFormType()

    ----初始化可选择英雄阵型列表
    --local camp_lsit = {}
    --if self.fun_form_type == PartnerConst.Fun_Form.Drama then--剧情副本 开放所有阵营的英雄
    --    self:onClickBtnShowByIndex(0)
    --else
    --    self:onClickBtnShowByIndex(0)
    --end
    --self:setCampBtnUnEnabled(camp_lsit)
    ----初始化可选择英雄阵型列表end
    --

    if self.show_type == HeroConst.FormShowType.eFormFight then
        if self.fun_form_type == PartnerConst.Fun_Form.Drama then
            if self.setting ~= nil then
                if self.setting.combat_sub_type == BattleConst.Drama_Sub_Type.Drama then
                    self.ctrl:send20050(1, self.setting.combat_dun_id, "")
                elseif self.setting.combat_sub_type == BattleConst.Drama_Sub_Type.Branch then
                    self.ctrl:send20050(2, self.setting.combat_dun_id, "")
                elseif self.setting.combat_sub_type == BattleConst.Drama_Sub_Type.Free then
                    self.ctrl:send20050(3, self.setting.combat_dun_id, "")
                elseif self.setting.combat_sub_type == BattleConst.Drama_Sub_Type.StoneDungeon then
                    self.ctrl:send20050(5, self.setting.combat_dun_id, "")
                end
            end
        elseif self.fun_form_type == PartnerConst.Fun_Form.Startower then
            self.ctrl:send20050(4, self.setting.tower_lev, "")

        end
    end
end

function GW_EmbattleWindow:open_callback()
    self.background = self.root_wnd:getChildByName("background")
    self.background:setScale(display.getMaxScale())
    local bg_res = PathTool.getPlistImgForDownLoad("gw_embattle", "1_bg_buzhen", true)
    if not self.background_load then
        self.background_load = loadImageTextureFromCDN(self.background, bg_res, ResourcesType.single, self.background_load)
    end

    self.spine_infos = self.root_wnd:getChildByName("spine_infos")
    self.spine_infos:setPositionX(display.getLeft())
    self.spine_infos:setPositionY(display.getBottom())
    self.left_top_infos = self.root_wnd:getChildByName("left_top_infos")
    self.left_top_infos:setPositionX(display.getLeft())
    self.left_top_infos:setPositionY(display.getTop())
    self.right_top_infos = self.root_wnd:getChildByName("right_top_infos")
    self.right_top_infos:setPositionX(display.getRight())
    self.right_top_infos:setPositionY(display.getTop())
    self.center_top_infos = self.root_wnd:getChildByName("center_top_infos")
    self.center_top_infos:setPositionY(display.getTop())
    self.left_bottom_infos = self.root_wnd:getChildByName("left_bottom_infos")
    self.left_bottom_infos:setPositionX(display.getLeft())
    self.left_bottom_infos:setPositionY(display.getBottom())
    self.right_bottom_infos = self.root_wnd:getChildByName("right_bottom_infos")
    self.right_bottom_infos:setPositionX(display.getRight())
    self.right_bottom_infos:setPositionY(display.getBottom())

    --中间英雄模型信息
    self.spine_infos_bg = self.spine_infos:getChildByName("bg")
    local bg_res = PathTool.getPlistImgForDownLoad("gw_embattle", "2_bg_gezi", false)
    if not self.spine_infos_bg_load then
        self.spine_infos_bg_load = loadSpriteTextureFromCDN(self.spine_infos_bg, bg_res, ResourcesType.single, self.spine_infos_bg_load)
    end
    self.spine_infos_pos_bg_list = {}
    self.spine_infos_pos_node_list = {}
    for i=1,9 do
        self.spine_infos_pos_bg_list[i] = self.spine_infos:getChildByName("pos_bg"..i)
        self.spine_infos_pos_bg_list[i]:setVisible(false)
        self.spine_infos_pos_node_list[i] = self.spine_infos:getChildByName("pos"..i)
    end
    --英雄模型展示
    local pos_rect_pos = {}
    self.fight_hero_node = self.spine_infos:getChildByName("fight_hero_node")
    for index=1,9 do
        pos_rect_pos[index] = cc.p(self.spine_infos_pos_node_list[index]:getPosition())

        self.hero_item_list[index] = GW_HeroSpineItem.new(1, false)
        self.hero_item_list[index]:setPosition(pos_rect_pos[index])
        self.hero_item_list[index]:setVisible(false)

        local zorder = 1
        if index%3 == 0 then
            zorder = 1
        elseif index%3 == 2 then
            zorder = 5
        else
            zorder = 10
        end
        self.fight_hero_node:addChild(self.hero_item_list[index], zorder)
    end
    self.pos_rect_list[1] = cc.rect(pos_rect_pos[1].x - 120, pos_rect_pos[1].y - 32, 240, 64)
    self.pos_rect_list[2] = cc.rect(pos_rect_pos[2].x - 120, pos_rect_pos[2].y - 32, 240, 64)
    self.pos_rect_list[3] = cc.rect(pos_rect_pos[3].x - 120, pos_rect_pos[3].y - 32, 240, 64)
    self.pos_rect_list[4] = cc.rect(pos_rect_pos[4].x - 120, pos_rect_pos[4].y - 32, 240, 64)
    self.pos_rect_list[5] = cc.rect(pos_rect_pos[5].x - 120, pos_rect_pos[5].y - 32, 240, 64)
    self.pos_rect_list[6] = cc.rect(pos_rect_pos[6].x - 120, pos_rect_pos[6].y - 32, 240, 64)
    self.pos_rect_list[7] = cc.rect(pos_rect_pos[7].x - 120, pos_rect_pos[7].y - 32, 240, 64)
    self.pos_rect_list[8] = cc.rect(pos_rect_pos[8].x - 120, pos_rect_pos[8].y - 32, 240, 64)
    self.pos_rect_list[9] = cc.rect(pos_rect_pos[9].x - 120, pos_rect_pos[9].y - 32, 240, 64)
    self.gw_pos_choose_btn_list = {}
    for i=1,9 do
        self.gw_pos_choose_btn_list[i] = self.spine_infos:getChildByName("pos_choose_btn"..i)
        self.gw_pos_choose_btn_list[i]:addTouchEventListener(function(sender, event_type)
            --customClickAction(sender, event_type)
            if event_type == ccui.TouchEventType.ended then
                playButtonSound2()
                if self.six_hero_vo[i] ~= nil then--当前格子已有英雄则下阵
                    self:onClickHeroItemEnd(i, sender)
                    self:updateNextUpPosShow()
                    return
                end
                if self.gw_cur_up_pos ~= nil and self.gw_cur_up_pos == i then return end
                if self.hero_item_list == nil then return end
                if self.hero_item_list[i] ~= nil and self.hero_item_list[i]:isVisible() == true then return end
                local count = 0
                for i,v in pairs(self.six_hero_vo) do
                    count = count + 1
                end
                if count >= 6 then
                    message(UI_TI18N(32003))
                    return
                end

                self.gw_cur_up_pos = i
                self:updateNextUpPosShow()
            end
        end)
    end

    --返回上一级
    self.back_btn = self.left_top_infos:getChildByName("back_btn")
    self.back_btn:getChildByName("label"):setString(UI_TI18N(10000002))
    self.back_btn:addTouchEventListener(function(sender, event_type)
        customClickAction(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            playButtonSound2()
            controller:openFormGoFightPanel(false)
        end
    end)
    --返回主城
    self.home_btn = self.right_top_infos:getChildByName("home_btn")
    self.home_btn:addTouchEventListener(function(sender, event_type)
        customClickAction(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            BackToHome()
        end
    end)

    --精灵神器信息
    self.hallow_elfin_infos = self.left_top_infos:getChildByName("hallow_elfin_infos")
    --神器信息
    self.hallow_info = self.hallow_elfin_infos:getChildByName("hallow_info")
    self.hallow_info:addTouchEventListener(function(sender, event_type)
        customClickAction_4(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            playButtonSound2()
            self:onClickEquipBtn()
        end
    end)
    self.hallow_info_icon = self.hallow_info:getChildByName("icon")
    self.hallow_info_icon:setVisible(false)
    self.hallow_info_redpoint = self.hallow_info:getChildByName("redpoint")
    if model.is_redpoint_hallows then
        if self.hallow_info_redpoint_spine == nil then
            self.hallow_info_redpoint_spine = PathTool.gw_createRedpointSpine()
            self.hallow_info_redpoint:addChild(self.hallow_info_redpoint_spine)
        end
        self.hallow_info_redpoint:setVisible(true)
    else
        self.hallow_info_redpoint:setVisible(false)
    end
    --精灵信息
    self.elfin_item_list = {}
    for i=1,4 do
        self.elfin_item_list[i] = self.hallow_elfin_infos:getChildByName("elfin_item"..i)
        self.elfin_item_list[i].active_info = self.elfin_item_list[i]:getChildByName("active")
        self.elfin_item_list[i].active_info:setVisible(false)
        self.elfin_item_list[i].active_icon = self.elfin_item_list[i].active_info:getChildByName("icon")
    end
    self.elfin_change_btn = self.hallow_elfin_infos:getChildByName("elfin_change_btn")
    self.elfin_change_btn:addTouchEventListener(function(sender, event_type)
        customClickAction_4(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            playButtonSound2()
            --FunctionNotOpenTips()
            --if not self.elfin_team_data_list[self.select_team_index] then return end
            --if not self.cur_tab_data then return end
            local elfin_tree_data = elfin_controller:getModel():getElfinTreeData()
            --古树信息没有回来不给点
            if next(elfin_tree_data) == nil then return end

            local setting = {}
            setting.fun_form_type = self.fun_form_type
            -- if self.fun_form_type == PartnerConst.Fun_Form.EliteMatch then
            --     local match_type = self.setting.match_type or ElitematchConst.MatchType.eNormalMatch
            --     if match_type == 2 then--王者赛
            --         setting.fun_form_type = PartnerConst.Fun_Form.EliteKingMatch
            --     end
            -- end
            self:setPlanSettingInfo(setting)
            ElfinController:getInstance():openElfinFightPlanPanel(true, setting)
            -- ElfinController:getInstance():openElfinAdjustWindow(true)
        end
    end)

    --敌方简略信息
    self.enemy_infos = self.right_top_infos:getChildByName("enemy_infos")
    self.enemy_infos:setVisible(false)
    --self.enemy_infos_detail_btn = self.enemy_infos:getChildByName("detail_btn")
    --self.enemy_infos_name = self.enemy_infos:getChildByName("name")
    --self.enemy_infos_power_icon = self.enemy_infos:getChildByName("power_icon")
    --self.enemy_infos_power = self.enemy_infos:getChildByName("power")
    --self.enemy_infos_pos_list = {}
    --for i=1,9 do
    --    self.enemy_infos_pos_list[i] = self.enemy_infos:getChildByName("pos"..i)
    --    self.enemy_infos_pos_list[i].icon = self.enemy_infos_pos_list[i]:getChildByName("icon")
    --end

    --敌方详细信息
    self.enemy_detail_panel = self.root_wnd:getChildByName("enemy_detail_panel")
    self.enemy_detail_panel:getChildByName("background"):setScale(display.getMaxScale())
    self.enemy_detail_panel:setVisible(false)

    --战力信息
    self.power_infos = self.center_top_infos:getChildByName("power_infos")
    local num_node = self.power_infos:getChildByName("num_node")
    self.power_infos_num = CommonNum.new(104, num_node, nil, -18, cc.p(0, 0.5))
    self.power_infos_num:setPosition(-5, 23)
    self.power_infos_num:setScale(0.76)
    --self.power_infos_num:setCallBack(function()
    --end)

    --阵型
    self.form_type = self.center_top_infos:getChildByName("form_type")
    self.form_type:addTouchEventListener(function(sender, event_type)
        customClickAction_4(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            playButtonSound2()
            BattleController:getInstance():openBattleCampView(true, self.halo_form_id_list)
        end
    end)
    self.form_type_colors = {}
    for pos=1,6 do
        self.form_type_colors[pos] = self.form_type:getChildByName(string_format("pos%s_color", pos))
    end
    self.form_type_attr_infos = self.center_top_infos:getChildByName("attr_infos")
    self.form_type_attr_list = {}
    for i=1,3 do
        self.form_type_attr_list[i] = self.form_type_attr_infos:getChildByName("attr"..i)
        self.form_type_attr_list[i]:setVisible(false)
        self.form_type_attr_list[i].icon = self.form_type_attr_list[i]:getChildByName("icon")
        self.form_type_attr_list[i].label = self.form_type_attr_list[i]:getChildByName("label")
    end

    local camp_node = self.left_bottom_infos:getChildByName("camp_node")
    self.camp_btn_list = {}
    for i=0,6 do
        self.camp_btn_list[i] = camp_node:getChildByName("camp_btn"..i)
        self.camp_btn_list[i]:addTouchEventListener(function(sender, event_type)
            customClickAction_4(sender, event_type)
            if event_type == ccui.TouchEventType.ended then
                playButtonSound2()
                self:onClickBtnShowByIndex(i)
            end
        end)
        self.camp_btn_list[i].select = self.camp_btn_list[i]:getChildByName("select")
        self.camp_btn_list[i].select:setVisible(false)
    end

    --英雄列表
    self.list_container = self.left_bottom_infos:getChildByName("list_container")
    self.list_container:setContentSize(cc.size(display.width - 313, 179))
    self.list_cover = self.left_bottom_infos:getChildByName("list_cover")
    self.list_cover:setPositionX(display.width - 313)


    self.other_infos = self.left_bottom_infos:getChildByName("other_infos")
    --已上阵信息
    self.num_infos = self.other_infos:getChildByName("num_infos")
    self.num_infos_label_1 = self.num_infos:getChildByName("label_1")
    self.num_infos_label_1:setString(UI_TI18N(32004))
    self.num_infos_label_2 = self.num_infos:getChildByName("label_2")
    self.num_infos_label_2:setPositionX(self.num_infos_label_1:getPositionX() + self.num_infos_label_1:getContentSize().width + 5)
    self.num_infos_label_3 = self.num_infos:getChildByName("label_3")
    self.num_infos_label_3:setPositionX(self.num_infos_label_2:getPositionX() + self.num_infos_label_2:getContentSize().width)
    self.num_infos_label_3:setString("/6")
    --条件信息
    self.condition_infos = self.other_infos:getChildByName("condition_infos")
    self.condition_infos:setVisible(false)
    self.condition_list = {}
    for i=1,2 do
        self.condition_list[i] = self.condition_infos:getChildByName("item"..i)
        self.condition_list[i].icon = self.condition_list[i]:getChildByName("icon")
        self.condition_list[i].label = self.condition_list[i]:getChildByName("label")
    end

    --一键上阵按钮
    self.key_up_btn = self.left_bottom_infos:getChildByName("key_up_btn")
    self.key_up_btn:setVisible(false)
    self.key_up_btn:addTouchEventListener(function(sender, event_type)
        customClickAction_4(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            playButtonSound2()
            self:onClickKeyUpBtn()
        end
    end)
    self.key_up_btn_label = self.key_up_btn:getChildByName("label")
    self.key_up_btn_label:setString(UI_TI18N(32005))
    self.key_up_btn_label:setFontSize(22)
    if self.key_up_btn_label:getContentSize().width > 100 then
        for k=1,10 do
            self.key_up_btn_label:setFontSize(22 - k)
            if self.key_up_btn_label:getContentSize().width <= 100 then
                break
            end
        end
    end
    --战斗按钮
    self.fight_btn = self.right_bottom_infos:getChildByName("fight_btn")
    self.fight_btn:setVisible(false)
    self.fight_btn:addTouchEventListener(function(sender, event_type)
        customClickAction_4(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            playButtonSound2()
            self:onClickFightBtn()
        end
    end)
    self.fight_btn_label = self.fight_btn:getChildByName("label")
    self.fight_btn_label:setString(UI_TI18N(32006))
    --保存按钮
    self.save_btn = self.right_bottom_infos:getChildByName("save_btn")
    self.save_btn:setVisible(false)
    self.save_btn:addTouchEventListener(function(sender, event_type)
        customClickAction_4(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            playButtonSound2()
            self:onClickSaveBtn()
        end
    end)
    self.save_btn_label = self.save_btn:getChildByName("label")
    self.save_btn_label:setString(UI_TI18N(32007))
    --阵容切换按钮
    self.formation_change_btn = self.right_bottom_infos:getChildByName("formation_change_btn")
    self.formation_change_btn:setVisible(false)
    self.formation_change_btn:addTouchEventListener(function(sender, event_type)
        if self.formation_choose_panel:isVisible() == false then
            customClickAction_4(sender, event_type)
        end
        if event_type == ccui.TouchEventType.ended then
            playButtonSound2()
            self:showFormationChoosePanel()
        end
    end)
    local label_node = self.formation_change_btn:getChildByName("label_node")
    self.formation_change_btn_label = createRichLabel(28, cc.c3b(0xe7,0xe6,0xe6), cc.p(0, 0.5), cc.p(0, 0), nil, nil, 1000)
    label_node:addChild(self.formation_change_btn_label)
    --阵容选择面板
    self.formation_choose_panel = self.right_bottom_infos:getChildByName("formation_choose_panel")
    self.formation_choose_panel:setVisible(false)
    self.formation_choose_list = {}
    for i=1,3 do
        self.formation_choose_list[i] = self.formation_choose_panel:getChildByName("item"..i)
        self.formation_choose_list[i]:addTouchEventListener(function(sender, event_type)
            customClickAction_4(sender, event_type)
            if event_type == ccui.TouchEventType.ended then
                playButtonSound2()
                self.formation_choose_panel:setVisible(false)
                if self.show_type == HeroConst.FormShowType.eFormSave then
                    if self.formation_choose_list[i].fun_form_type == PartnerConst.Fun_Form.Arena then--竞技场布阵先判断竞技场是否开启
                        local config = Config.CityData.data_base[CenterSceneBuild.arena]
                        if config == nil then
                            Debug.error("竞技入口配置找不到！city_data.xml ！ID:"..CenterSceneBuild.arena)
                            return
                        end
                        local open_status, lock_tips = MainuiController:getInstance():checkIsOpenByActivate(config.activate)
                        if open_status == false then
                            message(lock_tips)
                            return
                        end
                    elseif self.formation_choose_list[i].fun_form_type == PartnerConst.Fun_Form.ArenaChampion then--冠军赛布阵先判断冠军赛是否开启
                        local is_open = (Config.ArenaChampionData.data_const.is_open.val == 1)
                        if is_open ~= true then
                            FunctionNotOpenTips()
                            return
                        end

                        local config = Config.CityData.data_base[CenterSceneBuild.arena]
                        if config == nil then
                            Debug.error("竞技入口配置找不到！city_data.xml ！ID:"..CenterSceneBuild.arena)
                            return
                        end
                        local open_status, lock_tips = MainuiController:getInstance():checkIsOpenByActivate(config.activate)
                        if open_status == false then
                            message(lock_tips)
                            return
                        end
                    end
                    if self.formation_choose_list[i].fun_form_type ~= self.fun_form_type then
                        self.first_sort = nil
                        self.fun_form_type = self.formation_choose_list[i].fun_form_type
                        --在这里触发刷新阵容信息
                        self:updateFormationChangeBtnStatus()

                        --先初始化当前编辑阵容类型
                        self:updateFormType()
                    end
                end
            end
        end)
        self.formation_choose_list[i].icon = self.formation_choose_list[i]:getChildByName("icon")
        self.formation_choose_list[i].label_node = self.formation_choose_list[i]:getChildByName("label_node")
        self.formation_choose_list[i].label = createRichLabel(28, cc.c3b(0x59,0x6f,0x86), cc.p(0, 0.5), cc.p(0, 0), nil, nil, 1000)
        self.formation_choose_list[i].label_node:addChild(self.formation_choose_list[i].label)

        StringUtil.gw_setLabelContent(self.formation_choose_list[i].label, self.formation_choose_name_list[i], 160)
        self.formation_choose_list[i].fun_form_type = self.formation_choose_type_list[i]
    end

    --self.center_center_container = self.root_wnd:getChildByName("center_center_container")
    --self.left_top_container = self.root_wnd:getChildByName("left_top_container")
    --self.right_top_container = self.root_wnd:getChildByName("right_top_container")
    --self.left_botton_container = self.root_wnd:getChildByName("left_botton_container")
    --self.right_botton_container = self.root_wnd:getChildByName("right_botton_container")
    --
    --self.background = self.root_wnd:getChildByName("background")
    --if self.background ~= nil then
    --    self.background:loadTexture(PathTool.getPlistImgForDownLoad("gw_embattle","1_bg_buzhen", true), LOADTEXT_TYPE)
    --    --self.background:setScale(display.getMaxScale())
    --    ----self.background:setContentSize(cc.size(display.width,display.height))
    --end
    --
    ----返回上一级
    --self.back_btn = self.left_top_container:getChildByName("back_btn")
    --self.back_btn:addTouchEventListener(function(sender, event_type)
    --    if event_type == ccui.TouchEventType.ended then
    --        playButtonSound2()
    --        controller:openFormGoFightPanel(false)
    --    end
    --end)
    ----返回主城
    --self.home_btn = self.right_top_container:getChildByName("home_btn")
    --self.home_btn:addTouchEventListener(function(sender, event_type)
    --    if event_type == ccui.TouchEventType.ended then
    --        BackToHome()
    --    end
    --end)
    ----出击
    --self.fight_btn = self.right_botton_container:getChildByName("fight_btn")
    --self.fight_btn:getChildByName("label"):setString(TI18N("战斗"))
    ----保存
    --self.save_btn = self.right_botton_container:getChildByName("save_btn")
    --self.save_btn:getChildByName("label"):setString(TI18N("保存"))
    ----一键上阵
    --self.key_up_btn = self.right_botton_container:getChildByName("key_up_btn")
    --self.key_up_btn:getChildByName("label"):setString(TI18N("一键上阵"))
    ----阵容切换
    --self.formation_change_btn = self.right_botton_container:getChildByName("formation_change_btn")
    --self.formation_change_btn:getChildByName("label"):setString(TI18N("阵容切换"))
    --
    --
    ----英雄阵营
    --self.camp_btn_list = {}
    --for index=0,6 do
    --    self.camp_btn_list[index] = self.left_botton_container:getChildByName(string_format("camp_btn%s",index))
    --end
    --self.img_select = self.left_botton_container:getChildByName("img_select")
    --self.left_botton_container:getChildByName("label_0"):setString(TI18N("已上阵:"))
    --
    ----已上阵英雄数量
    --self.up_num_label = self.left_botton_container:getChildByName("up_num_label")
    --
    ----上阵条件限制提示
    --self.limit_tips_label = self.left_botton_container:getChildByName("limit_tips_label")
    --self.limit_tips_label:setVisible(false)
    --
    ----阵型
    --self.form_type = self.left_top_container:getChildByName("form_type")
    --self.form_type_icon = self.form_type:getChildByName("icon")
    --self.form_type_colors = {}
    --for pos=1,6 do
    --    self.form_type_colors[pos] = self.form_type:getChildByName(string_format("pos%s_color", pos))
    --end
    --self.form_attrs_node = self.left_top_container:getChildByName("form_attrs_node")
    --self.form_attrs = {}
    --
    ----总战力
    --self.total_battle_value_node = self.left_top_container:getChildByName("total_battle"):getChildByName("value_node")
    --self.total_battle = CommonNum.new(20, self.total_battle_value_node, 1, -2, cc.p(0, 0))
    --self.total_battle:setPosition(0, 0)
    --self.left_top_container:getChildByName("total_battle"):getChildByName("label"):setString(TI18N("总战力"))
    --
    ----敌方信息
    --self.enemy_info = self.right_top_container:getChildByName("enemy_info")
    --self.enemy_info_detail_info_open_btn = self.enemy_info:getChildByName("detail_info_open_btn")
    --self.enemy_info_pos_infos = {}
    --for pos=1,9 do
    --    self.enemy_info_pos_infos[pos] = self.enemy_info:getChildByName(string_format("pos%s", pos)):getChildByName("camp_type")
    --end
    --self.enemy_info:setVisible(false)
    --self.enemy_info:getChildByName("label"):setString(TI18N("敌方"))
    --self.enemy_info:getChildByName("tips_label"):setString(TI18N("前排"))
    --
    ----英雄模型展示
    --local pos_rect_pos = {}
    --self.fight_hero_node = self.center_center_container:getChildByName("bg_img")
    --for index=1,9 do
    --    pos_rect_pos[index] = cc.p(self.fight_hero_node:getChildByName("pos"..index):getPosition())
    --
    --    self.hero_item_list[index] = GW_HeroSpineItem.new(1, false)
    --    self.hero_item_list[index]:setPosition(pos_rect_pos[index])
    --
    --    local zorder = 1
    --    if index%3 == 0 then
    --        zorder = 1
    --    elseif index%3 == 2 then
    --        zorder = 5
    --    else
    --        zorder = 10
    --    end
    --    self.fight_hero_node:addChild(self.hero_item_list[index], zorder)
    --end
    --self.pos_rect_list[1] = cc.rect(pos_rect_pos[1].x - 80, pos_rect_pos[1].y - 30, 160, 60)
    --self.pos_rect_list[2] = cc.rect(pos_rect_pos[2].x - 80, pos_rect_pos[2].y - 30, 160, 60)
    --self.pos_rect_list[3] = cc.rect(pos_rect_pos[3].x - 80, pos_rect_pos[3].y - 30, 160, 60)
    --self.pos_rect_list[4] = cc.rect(pos_rect_pos[4].x - 80, pos_rect_pos[4].y - 30, 160, 60)
    --self.pos_rect_list[5] = cc.rect(pos_rect_pos[5].x - 80, pos_rect_pos[5].y - 30, 160, 60)
    --self.pos_rect_list[6] = cc.rect(pos_rect_pos[6].x - 80, pos_rect_pos[6].y - 30, 160, 60)
    --self.pos_rect_list[7] = cc.rect(pos_rect_pos[7].x - 80, pos_rect_pos[7].y - 30, 160, 60)
    --self.pos_rect_list[8] = cc.rect(pos_rect_pos[8].x - 80, pos_rect_pos[8].y - 30, 160, 60)
    --self.pos_rect_list[9] = cc.rect(pos_rect_pos[9].x - 80, pos_rect_pos[9].y - 30, 160, 60)
    --
    ----英雄列表
    --self.lay_scrollview = self.left_botton_container:getChildByName("lay_scrollview")
    --
    --
    ----播放窗口动画
    --self:playEnterAnimatianByObj(self.root_wnd , 1)

end

function GW_EmbattleWindow:register_event()
    --registerButtonEventListener(self.fight_btn, handler(self, self.onClickFightBtn) ,true, REGISTER_BUTTON_SOUND_CLOSED_TYPY)
    --registerButtonEventListener(self.save_btn, handler(self, self.onClickSaveBtn) ,true, REGISTER_BUTTON_SOUND_CLOSED_TYPY)
    --registerButtonEventListener(self.key_up_btn, handler(self, self.onClickKeyUpBtn) ,true, REGISTER_BUTTON_SOUND_CLOSED_TYPY)
    --registerButtonEventListener(self.form_type, handler(self, self.onClickFormTypeBtn) ,true, REGISTER_BUTTON_SOUND_CLOSED_TYPY)

    ----阵营按钮
    --for select_camp, v in pairs(self.camp_btn_list) do
    --    registerButtonEventListener(v, function()
    --        self:onClickBtnShowByIndex(select_camp)
    --    end ,false, REGISTER_BUTTON_SOUND_CLOSED_TYPY)
    --end
    --
    --上阵中的6个英雄
    self.long_touch_type = LONG_TOUCH_INIT_TYPE
    for i,item in ipairs(self.hero_item_list) do
        item:addTouchEventListener(function(sender, event_type)
            --播放动作中 和 数据为空
            if self.is_play_item_action then return end
            if event_type == ccui.TouchEventType.began then
                self.touch_began = sender:getTouchBeganPosition()
                self.long_touch_type = LONG_TOUCH_BEGAN_TYPE
                delayRun(self.fight_hero_node, 0.6, function ()
                    if self.long_touch_type == LONG_TOUCH_BEGAN_TYPE then
                        local hero_vo = self.six_hero_vo[i]
                        if hero_vo then
                            if hero_vo.is_endless == nil or hero_vo.is_endless == false then
                                HeroController:getInstance():openHeroTipsPanel(true, hero_vo)
                            else
                                LookController:getInstance():sender11061(hero_vo.rid, hero_vo.srv_id, hero_vo.id)
                            end
                        end
                    end
                    self.long_touch_type = LONG_TOUCH_END_TYPE
                end)

            elseif event_type == ccui.TouchEventType.moved then
                if self.long_touch_type == LONG_TOUCH_END_TYPE then
                    --事件触发了就不处理移动事件了
                    return
                elseif self.long_touch_type == LONG_TOUCH_BEGAN_TYPE then
                    local touch_began = self.touch_began
                    local touch_end = sender:getTouchMovePosition()
                    if touch_began and touch_end then
                        if math.abs(touch_end.x - touch_began.x) > 1 or math.abs(touch_end.y - touch_began.y) > 1 then
                            --移动大于20了..表示取消长点击效果
                            doStopAllActions(self.fight_hero_node)
                            self.long_touch_type = LONG_TOUCH_CANCEL_TYPE
                        end
                    end
                end
                self:onClickHeroItemMove(i, sender)
            elseif event_type == ccui.TouchEventType.canceled then
                if self.long_touch_type == LONG_TOUCH_BEGAN_TYPE then
                    doStopAllActions(self.fight_hero_node)
                    self.long_touch_type = LONG_TOUCH_CANCEL_TYPE
                elseif self.long_touch_type == LONG_TOUCH_END_TYPE then
                    --事件触发了就不处理点击事件了
                    if self.move_hero_item then
                        self.move_hero_item:setPosition(-10000, 0)
                    end
                    item:setData(self.six_hero_vo[i])
                    return
                end

                self:onClickHeroItemCanceled(i, sender)
            elseif event_type == ccui.TouchEventType.ended then
                if self.long_touch_type == LONG_TOUCH_BEGAN_TYPE then
                    doStopAllActions(self.fight_hero_node)
                    self.long_touch_type = LONG_TOUCH_CANCEL_TYPE
                elseif self.long_touch_type == LONG_TOUCH_CANCEL_TYPE then
                    self:onClickHeroItemCanceled(i, sender)
                    return
                elseif self.long_touch_type == LONG_TOUCH_END_TYPE then
                    --事件触发了就不处理点击事件了
                    if self.move_hero_item then
                        self.move_hero_item:setPosition(-10000, 0)
                    end
                    item:setData(self.six_hero_vo[i])
                    return
                end

                self:onClickHeroItemEnd(i, sender)
            end
        end)
    end

    --
    --布阵信息返回
    self:addGlobalEvent(HeroEvent.Update_Fun_Form, function(data)
        if not data then return end
        if self.fun_form_type and data.type and data.type == self.fun_form_type then
            self:initFormInfo(data)
        end
    end)

    --保存布阵信息返回
    self:addGlobalEvent(HeroEvent.Update_Save_Form, function(data)
        Debug.log(string_format("self.show_type:%s", self.show_type))
        if self.show_type == HeroConst.FormShowType.eFormFight then --出战
            self:gotoFight()
        else
            message(UI_TI18N(32008))
            if self.fun_form_type == PartnerConst.Fun_Form.Drama then
                if data.type ~= PartnerConst.Fun_Form.Drama then
                    controller:sender11211(data.type)
                end
            end

            ----出战状态才会在保存布阵信息返回后关闭布阵界面
            --if self.show_type == HeroConst.FormShowType.eFormFight then
            --    self:onClickCloseBtn()
            --end
        end
    end)

    --敌方信息返回
    self:addGlobalEvent(GW_EmbattleEvent.UPDATE_ENEMY_INFO, function(data)
        self:updateEnemyInfo(data)
    end)


    self:addGlobalEvent(ElfinEvent.Get_Elfin_Tree_Data_Event, function (  )
        if self.save_elfin_data then
            self:updateElfinList(self.save_elfin_data)
        end
    end)

    --阵法类型对应精灵数据
    self:addGlobalEvent(ElfinEvent.Elfin_Plan_From_Info_Event, function (data)
        self:initEflinInfoList(data)
    end)
end

function GW_EmbattleWindow:close_callback()
    doStopAllActions(self.background)
    doStopAllActions(self.enemy_detail_panel_main_container)
    if self.background_load then
        self.background_load:DeleteMe()
        self.background_load = nil
    end
    if self.spine_infos_bg_load then
        self.spine_infos_bg_load:DeleteMe()
        self.spine_infos_bg_load = nil
    end
    self.power_infos_num = nil
    self.form_type_colors = nil
    self.form_type_attr_list = nil

    if self.hallow_info_redpoint_spine ~= nil then
        self.hallow_info_redpoint_spine:clearTracks()
        self.hallow_info_redpoint_spine:removeFromParent()
        self.hallow_info_redpoint_spine = nil
    end


    --if self.hero_item_list_timer ~= nil then
    --    GlobalTimeTicket:getInstance():remove(self.hero_item_list_timer)
    --    self.hero_item_list_timer = nil
    --end

    if self.list_view then
        self.list_view:DeleteMe()
        self.list_view = nil
    end

    local hero_list = model:getHeroList()
    for k, hero_vo in pairs(hero_list) do
        hero_vo.is_ui_select = nil
    end

    if self.fun_form_type == PartnerConst.Fun_Form.Planes then -- 位面冒险
        local all_hero_list = PlanesafkController:getInstance():getModel():getAllPlanesHeroData()
        for _,v in pairs(all_hero_list) do
            v.is_ui_select = nil
        end
    elseif self.fun_form_type == PartnerConst.Fun_Form.EndLess or
            self.fun_form_type == PartnerConst.Fun_Form.EndLessWater or
            self.fun_form_type == PartnerConst.Fun_Form.EndLessFire or
            self.fun_form_type == PartnerConst.Fun_Form.EndLessWind or
            self.fun_form_type == PartnerConst.Fun_Form.EndLessSoil or
            self.fun_form_type == PartnerConst.Fun_Form.EndLessLightDark then -- 无尽冒险
        local list = self.setting.has_hire_list or {}
        for i,v in ipairs(list) do
            v.is_ui_select = nil
        end
    end

    self.ctrl:closeEmbattleView()
end

--出击
function GW_EmbattleWindow:onClickFightBtn(force)
    if not self.fun_form_type  then return end

    if self.fun_form_type == PartnerConst.Fun_Form.EndLess or
            self.fun_form_type == PartnerConst.Fun_Form.EndLessWater or
            self.fun_form_type == PartnerConst.Fun_Form.EndLessFire or
            self.fun_form_type == PartnerConst.Fun_Form.EndLessWind or
            self.fun_form_type == PartnerConst.Fun_Form.EndLessLightDark or
            self.fun_form_type == PartnerConst.Fun_Form.EndLessSoil then
        --无尽试炼
        self:onFightEndLess()
    else
        self:onSaveTeam()
    end
end
--发送无尽试炼
function GW_EmbattleWindow:onFightEndLess()
    if not self.six_hero_vo then return end

    local pos_info = {}
    for i=1,9 do
        if self.six_hero_vo[i] ~= nil then
            local d = {}
            d.pos = i;
            d.owner_id = self.six_hero_vo[i].rid
            d.owner_srv_id = self.six_hero_vo[i].srv_id
            d.id = self.six_hero_vo[i].partner_id
            table_insert(pos_info, d)
        end
    end

    if #pos_info == 0 then
        message(UI_TI18N(32009))
        return
    end

    local type = Endless_trailEvent.endless_type.old
    if self.fun_form_type == PartnerConst.Fun_Form.EndLessWater then--水系
        type = Endless_trailEvent.endless_type.water
    elseif self.fun_form_type == PartnerConst.Fun_Form.EndLessFire then--火系
        type = Endless_trailEvent.endless_type.fire
    elseif self.fun_form_type == PartnerConst.Fun_Form.EndLessWind then--风系
        type = Endless_trailEvent.endless_type.wind
    elseif self.fun_form_type == PartnerConst.Fun_Form.EndLessLightDark then--光暗系
        type = Endless_trailEvent.endless_type.light_dark
    elseif self.fun_form_type == PartnerConst.Fun_Form.EndLessSoil then--土系
        type = Endless_trailEvent.endless_type.soil
    end
    Endless_trailController:getInstance():send23901(type,self.formation_type, pos_info, self.hallows_id)
    --self:onClickCloseBtn()
end

function GW_EmbattleWindow:onClickCloseBtn(force)
    if not force and self.fun_form_type and self.fun_form_type == PartnerConst.Fun_Form.Monopoly_Evt then
        -- 大富翁事件的布阵界面不能关闭
        return
    elseif self.fun_form_type and self.fun_form_type == PartnerConst.Fun_Form.Adventure_Mine_Def then
        controller:openAdventureMineFormGoFightPanel(false)
        if self.setting and self.setting.end_time then
            local time = self.setting.end_time - GameNet:getInstance():getTime()
            if time > 0 then
                local adventure_controller = AdventureController:getInstance()
                if adventure_controller and adventure_controller.send20660 then
                    --bugly报错(send20660 is a nil value). 兼容一下
                    adventure_controller:send20660(self.setting.floor, self.setting.room_id)
                end
            end
        end
    else
        controller:openFormGoFightPanel(false)
    end
end
--保存
function GW_EmbattleWindow:onClickSaveBtn(force)
    self:onSaveTeam()
end
--一键上阵
function GW_EmbattleWindow:onClickKeyUpBtn(force)
    local _getPos = function(hero_vo)
        for i=1,9 do
            if self.six_hero_vo[i] == nil then
                return i
            end
        end

        return nil
    end

    --取得所有英雄数据
    local hero_array = model:getAllHeroArray()

    local vo = Array.New()
    local temp_power = 0
    for j=1,hero_array:GetSize() do
        local hero_vo = hero_array:Get(j-1)
        vo:PushBack(hero_vo)
        if self.fun_form_type == PartnerConst.Fun_Form.EndLessLightDark and hero_vo and (hero_vo.camp_type == HeroConst.CampType.eLight or hero_vo.camp_type == HeroConst.CampType.eDark) then
            if hero_vo and temp_power < hero_vo.power then
                temp_power = hero_vo.power
            end
        elseif self.select_camp == 0 or (self.select_camp == hero_vo.camp_type) then
            if hero_vo and temp_power < hero_vo.power then
                temp_power = hero_vo.power
            end
        end
    end
    if self.fun_form_type == PartnerConst.Fun_Form.EndLess or
            self.fun_form_type == PartnerConst.Fun_Form.EndLessWater or
            self.fun_form_type == PartnerConst.Fun_Form.EndLessFire or
            self.fun_form_type == PartnerConst.Fun_Form.EndLessWind or
            self.fun_form_type == PartnerConst.Fun_Form.EndLessSoil or
            self.fun_form_type == PartnerConst.Fun_Form.EndLessLightDark then
        local list = self.setting.has_hire_list or {}
        local partner_config = Config.PartnerData.data_partner_base
        for i,v in ipairs(list) do
            if self.fun_form_type == PartnerConst.Fun_Form.EndLess then
                local config  = partner_config[v.bid]
                v.partner_id = v.id
                v.camp_type = config.camp_type
                v.is_endless = true --是否无尽试炼雇佣兵
                vo:PushBack(v)
            elseif self.fun_form_type == PartnerConst.Fun_Form.EndLessWater or
                    self.fun_form_type == PartnerConst.Fun_Form.EndLessFire or
                    self.fun_form_type == PartnerConst.Fun_Form.EndLessWind or
                    self.fun_form_type == PartnerConst.Fun_Form.EndLessSoil then
                if (temp_power and v.power <= temp_power*1.2) then
                    local config  = partner_config[v.bid]
                    if (self.select_camp == config.camp_type) then
                        v.partner_id = v.id
                        v.camp_type = config.camp_type
                        v.is_endless = true --是否无尽试炼雇佣兵
                        vo:PushBack(v)
                    end
                end
            elseif self.fun_form_type == PartnerConst.Fun_Form.EndLessLightDark then
                if (temp_power and v.power <= temp_power*1.2) then
                    local config  = partner_config[v.bid]
                    if (config.camp_type == HeroConst.CampType.eLight) or (config.camp_type == HeroConst.CampType.eDark) then
                        v.partner_id = v.id
                        v.camp_type = config.camp_type
                        v.is_endless = true --是否无尽试炼雇佣兵
                        vo:PushBack(v)
                    end
                end
            end

        end
    end

    vo:UpperSortByParams("power", "star", "lev", "sort_order")
    --hero_array:UpperSortByParams("power", "star", "lev", "sort_order")
    local index = 1
    local size = vo:GetSize()
    if size == 0 then
        message(UI_TI18N(32010))
        return
    end

    --清空选中
    local temp_hero_vo = {}

    local pos_index = 1
    for j=1,vo:GetSize() do
        local hero_vo = vo:Get(j-1)
        if hero_vo ~= nil then
            local gw_flag = false
            if self.gw_camp_type_limit ~= nil and next(self.gw_camp_type_limit) ~= nil then
                local gw_is_flag = false
                for i,v in pairs(self.gw_camp_type_limit) do
                    if hero_vo.camp_type == v then
                        gw_is_flag = true
                        break
                    end
                end

                if gw_is_flag == false then
                    gw_flag = true
                end
            end

            if gw_flag == false then
                local flag = true
                for k,v in pairs(temp_hero_vo) do
                    if v.partner_id == hero_vo.partner_id then
                        flag = false
                        break
                    end
                    if v.bid == hero_vo.bid then
                        flag = false
                        break
                    end
                end

                if flag == true then
                    temp_hero_vo[pos_index] = {}
                    temp_hero_vo[pos_index] = hero_vo

                    pos_index = pos_index + 1
                    if pos_index > 6 then
                        break
                    end
                end
            end
        end
    end

    if temp_hero_vo == nil or next(temp_hero_vo) == nil then
        message(UI_TI18N(32010))
        return
    end

    local flag = false
    for i=1,9 do
        if temp_hero_vo[i] == nil then
            if self.six_hero_vo[i] ~= nil then
                flag = true
                break
            end
        else
            if self.six_hero_vo[i] == nil then
                flag = true
                break
            else
                if temp_hero_vo[i].id ~= self.six_hero_vo[i].id then
                    flag = true
                    break
                elseif temp_hero_vo[i].partner_id ~= self.six_hero_vo[i].partner_id then
                    flag = true
                    break
                end
            end
        end
    end

    if flag == false then
        return
    end

    self.six_hero_vo = temp_hero_vo

    self:updateSixHeroItem()
    --更新阵营
    self:updateHallowsIcon()
    --更新战力显示
    self:updateFightPower()
    --更新阵型触发属性
    self:calculateCampHaloType()
end

--发送保存布阵队伍
function GW_EmbattleWindow:onSaveTeam()
    if not self.six_hero_vo then return end

    local pos_info = {}
    for i=1,9 do
        if self.six_hero_vo[i] ~= nil then
            local d = {}
            d.pos = i;
            d.id = self.six_hero_vo[i].partner_id
            table_insert(pos_info, d)
        end
    end

    if #pos_info == 0 then
        message(UI_TI18N(32009))
        return
    end

    if self.fun_form_type == PartnerConst.Fun_Form.Drama then
        controller:sender11212(self.fun_form_type, self.formation_type, pos_info, self.hallows_id)
    else
        controller:sender11212(self.fun_form_type, self.formation_type, pos_info, self.hallows_id)
    end
end

--真正出战
function GW_EmbattleWindow:gotoFight()
    if self.fun_form_type == PartnerConst.Fun_Form.Drama then--关卡战斗
        if self.setting ~= nil and self.setting.combat_sub_type then
            if self.setting.combat_sub_type == BattleConst.Drama_Sub_Type.Drama then--剧情战斗
                BattleDramaController:getInstance():send13003(0)
                --剧情战斗中不执行引导，引导通过胜利结算页面关闭发送执行引导事件
                GuideController:getInstance():setDramaBattleStates(true)
            elseif self.setting.combat_sub_type == BattleConst.Drama_Sub_Type.Branch then--支线战斗
                BattleDramaController:getInstance():gw_send13023(self.setting.combat_dun_id)
            elseif self.setting.combat_sub_type == BattleConst.Drama_Sub_Type.Free then--自由战斗
                BattleDramaController:getInstance():gw_send13027(self.setting.combat_dun_id)
            elseif self.setting.combat_sub_type == BattleConst.Drama_Sub_Type.StoneDungeon then--日常副本战斗
                Stone_dungeonController:getInstance():send13031(self.setting.combat_dun_id)
            elseif self.setting.combat_sub_type == BattleConst.Drama_Sub_Type.Arena then--竞技场战斗
                ArenaController:getInstance():requestFightWithLoopChallenge(self.setting.combat_rid, self.setting.combat_srv_id, self.setting.combat_status)
            else
                message("未知的剧情布阵战斗子类型："..self.setting.combat_sub_type)
            end
        end
        --MainuiController:getInstance():requestOpenBattleRelevanceWindow(BattleConst.Fight_Type.Darma)
        --BattleDramaController:getInstance():send13003(0)
    elseif self.fun_form_type == PartnerConst.Fun_Form.Startower then
        --试练塔 --星命塔
        self:onFightStarTower()
    elseif self.fun_form_type == PartnerConst.Fun_Form.GuildDun_AD then
        -- 联盟副本
        self:onFightGuildDun()
    end
end
--发送试练塔
function GW_EmbattleWindow:onFightStarTower()
    local tower = self.setting.tower_lev or 0
    StartowerController:getInstance():sender11322(tower)
end
--发送联盟副本
function GW_EmbattleWindow:onFightGuildDun()
    local pos_info = {}
    for i=1,9 do
        if self.six_hero_vo[i] ~= nil then
            local d = {}
            d.pos = i;
            d.owner_id = self.six_hero_vo[i].rid
            d.owner_srv_id = self.six_hero_vo[i].srv_id
            d.id = self.six_hero_vo[i].partner_id
            table_insert(pos_info, d)
        end
    end

    if #pos_info == 0 then
        message(UI_TI18N(32009))
        return
    end

    local boss_id = self.setting.boss_id
    GuildbossController:getInstance():send21308(boss_id, self.formation_type, pos_info, self.hallows_id)
    --self:onClickCloseBtn()
end

function GW_EmbattleWindow:onClickFormTypeBtn()
    BattleController:getInstance():openBattleCampView(true, self.halo_form_id_list)
end

--点击6个英雄Item move
function GW_EmbattleWindow:onClickHeroItemMove(index, sender)
    if not self.six_hero_vo then return end
    if not self.six_hero_vo[index] then return end

    if self.is_move_hero == nil or self.is_move_hero == false then
        self.gw_hero_move_start_mouse_pos = sender:getTouchMovePosition()
        self.gw_hero_move_start_item_pos_x = self.hero_item_list[index]:getPositionX()
        self.gw_hero_move_start_item_pos_y = self.hero_item_list[index]:getPositionY()
    end

    if self.gw_hero_move_start_mouse_pos == nil then
        self.gw_hero_move_start_mouse_pos = sender:getTouchMovePosition()
    end
    if self.gw_hero_move_start_item_pos_x == nil then
        self.gw_hero_move_start_item_pos_x = self.hero_item_list[index]:getPositionX()
    end
    if self.gw_hero_move_start_item_pos_y == nil then
        self.gw_hero_move_start_item_pos_y = self.hero_item_list[index]:getPositionY()
    end

    --判断是否有移动
    self.is_move_hero = true

    if self.move_hero_item == nil then
        self.move_hero_item = GW_HeroSpineItem.new(1, false)
        self.fight_hero_node:addChild(self.move_hero_item, 15)
    end
    self.move_hero_item:setData(self.six_hero_vo[index])
    self.hero_item_list[index]:setData(nil)

    local touch_pos = sender:getTouchMovePosition()
    local target_x = self.gw_hero_move_start_item_pos_x + touch_pos.x - self.gw_hero_move_start_mouse_pos.x
    local target_y = self.gw_hero_move_start_item_pos_y + touch_pos.y - self.gw_hero_move_start_mouse_pos.y
    self.move_hero_item:setPositionX(target_x)
    self.move_hero_item:setPositionY(target_y)
    --local target_pos = self.fight_hero_node:convertToNodeSpace(touch_pos)
    --self.move_hero_item:setPosition(target_pos)

    local target_pos = cc.p(self.move_hero_item:getPosition())

    for i,v in pairs(self.spine_infos_pos_bg_list) do
        v:setVisible(self.six_hero_vo[i] ~= nil)
    end

    for i,rect in ipairs(self.pos_rect_list) do
        if cc.rectContainsPoint( rect, target_pos ) then
            self.spine_infos_pos_bg_list[i]:setVisible(true)
            break
        end
    end
end

--点击6个英雄Item Cancel
function GW_EmbattleWindow:onClickHeroItemCanceled(index, sender)
    if not self.six_hero_vo then return end
    self.is_move_hero = false
    if self.move_hero_item then
        if self.gw_hero_move_start_mouse_pos == nil then
            self.gw_hero_move_start_mouse_pos = sender:getTouchMovePosition()
        end
        if self.gw_hero_move_start_item_pos_x == nil then
            self.gw_hero_move_start_item_pos_x = self.hero_item_list[index]:getPositionX()
        end
        if self.gw_hero_move_start_item_pos_y == nil then
            self.gw_hero_move_start_item_pos_y = self.hero_item_list[index]:getPositionY()
        end

        --local touch_pos = sender:getTouchMovePosition()
        --local target_x = self.gw_hero_move_start_item_pos_x + touch_pos.x - self.gw_hero_move_start_mouse_pos.x
        --local target_y = self.gw_hero_move_start_item_pos_y + touch_pos.y - self.gw_hero_move_start_mouse_pos.y
        local target_pos = cc.p(self.move_hero_item:getPosition())
        for i,rect in ipairs(self.pos_rect_list) do
            if cc.rectContainsPoint( rect, target_pos ) then
                if i ~= index then
                    --转换
                    self.hero_item_list[i]:setData(self.six_hero_vo[index])
                    local temp_hero_vo = self.six_hero_vo[i]
                    self.six_hero_vo[i] = self.six_hero_vo[index]

                    if temp_hero_vo ~= nil then
                        self.hero_item_list[index]:setData(temp_hero_vo)
                        self.six_hero_vo[index] = temp_hero_vo
                    else
                        self.hero_item_list[index]:setData(nil)
                        self.six_hero_vo[index] = nil
                    end

                    --相当于隐藏
                    self.move_hero_item:setPosition(-10000, 0)

                    --更新阵法元素
                    self:updateHallowsIcon()

                    return
                else
                    --相当于隐藏
                    self.move_hero_item:setPosition(-10000, 0)
                    self.hero_item_list[index]:setData(self.six_hero_vo[index])
                    return
                    --点自己是下阵了
                    --这里系统直接执行 self:onClickHeroItemEnd()方法了
                end
            end
        end

        ----相当于隐藏
        --self.move_hero_item:setPosition(-10000, 0)
    end

    self:onClickHeroItemEnd(index, sender)

    --local touch_pos = sender:getTouchMovePosition()
    --local target_pos = self.fight_hero_node:convertToNodeSpace(touch_pos)
    --for i,rect in ipairs(self.pos_rect_list) do
    --    if cc.rectContainsPoint( rect, target_pos ) then
    --        if i ~= index then
    --            --转换
    --            self.hero_item_list[i]:setData(self.six_hero_vo[index])
    --            local temp_hero_vo = self.six_hero_vo[i]
    --            self.six_hero_vo[i] = self.six_hero_vo[index]
    --
    --            if temp_hero_vo ~= nil then
    --                self.hero_item_list[index]:setData(temp_hero_vo)
    --                self.six_hero_vo[index] = temp_hero_vo
    --            else
    --                self.hero_item_list[index]:setData(nil)
    --                self.six_hero_vo[index] = nil
    --            end
    --
    --            --更新阵法元素
    --            self:updateHallowsIcon()
    --            return
    --        else
    --            --点自己是下阵了
    --            --这里系统直接执行 self:onClickHeroItemEnd()方法了
    --        end
    --    end
    --end
    --
    --self.hero_item_list[index]:setData(self.six_hero_vo[index])
    ----更新阵法元素
    --self:updateHallowsIcon()

end

--点击6个英雄Item end
function GW_EmbattleWindow:onClickHeroItemEnd(index, sender)
    if not self.six_hero_vo then return end
    if self.move_hero_item then
        --相当于隐藏
        self.move_hero_item:setPosition(-10000, 0)
    end

    --说明是点击了 item 下阵
    if self.list_view then
        local item_list = self.list_view:getActiveCellList() or {}
        for i,item in ipairs(item_list) do
            local hero_vo = item:getData()

            if self.six_hero_vo[index] and hero_vo and hero_vo.partner_id == self.six_hero_vo[index].partner_id and
                    hero_vo.rid == self.six_hero_vo[index].rid and
                    hero_vo.srv_id == self.six_hero_vo[index].srv_id then
                hero_vo.is_ui_select = false
                item:setSelected(hero_vo.is_ui_select)
                --结束位置
                local world_pos = item:convertToWorldSpace(cc.p(GW_HeroSpineItem.Width * 0.5, GW_HeroSpineItem.Height * 0.5))
                local end_pos = self.fight_hero_node:convertToNodeSpace(world_pos)
                local x, y =  self.hero_item_list[index]:getPosition()
                self:showMoveEffect(cc.p(x,y), end_pos, hero_vo)

                self.hero_item_list[index]:setData(nil)
                self.six_hero_vo[index] = nil
                --更新战力显示
                self:updateFightPower()
                --更新阵法元素
                self:updateHallowsIcon()
                --更新阵型触发属性
                self:calculateCampHaloType()
                return
            end
        end
    end
    --上面没有找到 直接下阵
    local hero_vo = self.six_hero_vo[index]
    if not hero_vo then return end
    local item = self.camp_btn_list[hero_vo.camp_type]
    if item == nil then
        --默认是全部那个
        item = self.camp_btn_list[0]
    end
    local world_pos = item:convertToWorldSpace(cc.p(58 * 0.5, 58 * 0.5))
    local end_pos = self.fight_hero_node:convertToNodeSpace(world_pos)
    local x, y =  self.hero_item_list[index]:getPosition()
    self:showMoveEffect(cc.p(x,y), end_pos, hero_vo)

    self.six_hero_vo[index].is_ui_select = false
    self.hero_item_list[index]:setData(nil)
    self.six_hero_vo[index] = nil

    --更新阵法元素
    self:updateHallowsIcon()
end

--刷新当前阵容类型
function GW_EmbattleWindow:updateFormType()
    self:sendByFormType(self.fun_form_type)
end
--发送获取队伍信息 根据队伍类型
function GW_EmbattleWindow:sendByFormType(fun_form_type)
    --controller:sender11211(fun_form_type)

    if fun_form_type == PartnerConst.Fun_Form.Drama then
        local pos_list =  model:getMyPosList()
        local data = {}
        data.formation_type = model.use_formation_type
        data.hallows_id = model.use_hallows_id
        data.pos_info = pos_list
        self:initFormInfo(data)
    elseif fun_form_type == PartnerConst.Fun_Form.EliteMatch then
        local match_type = self.setting.match_type or ElitematchConst.MatchType.eNormalMatch
        ElitematchController:getInstance():sender24920(match_type)
    elseif fun_form_type == PartnerConst.Fun_Form.Heaven then
        HeavenController:getInstance():sender25210(1)
    elseif fun_form_type == PartnerConst.Fun_Form.HeavenBoss then
        HeavenController:getInstance():sender25210(2)
    elseif fun_form_type == PartnerConst.Fun_Form.CrossArena then
        CrossarenaController:getInstance():sender25605(1)
    elseif fun_form_type == PartnerConst.Fun_Form.CrossArenaDef then
        CrossarenaController:getInstance():sender25605(2)
    elseif fun_form_type == PartnerConst.Fun_Form.ArenapeakchampionDef then
        ArenapeakchampionController:getInstance():sender27726()
    elseif fun_form_type == PartnerConst.Fun_Form.Adventure_Mine_Def then
        --秘矿冒险
        self:initMineFormInfo()
    elseif fun_form_type == PartnerConst.Fun_Form.Planes then -- 位面
        PlanesafkController:getInstance():sender28612()
    else
        --其他的都根据协议获取阵容
        controller:sender11211(fun_form_type)
    end

    --精灵布阵的获取
    if fun_form_type == PartnerConst.Fun_Form.EliteMatch then
        local match_type = self.setting.match_type or ElitematchConst.MatchType.eNormalMatch
        if match_type == 1 then
            elfin_controller:send26555(PartnerConst.Fun_Form.EliteMatch)
        else
            elfin_controller:send26555(PartnerConst.Fun_Form.EliteKingMatch)
        end
    else
        elfin_controller:send26555(fun_form_type)
    end
end

--根据显示类型显示隐藏开战、保存按钮
function GW_EmbattleWindow:setShowTypeUI()
    if self.show_type == HeroConst.FormShowType.eFormFight then--出战
        self.fight_btn:setVisible(true)
        self.save_btn:setVisible(false)
    elseif self.show_type == HeroConst.FormShowType.eFormSave then --保存
        self.fight_btn:setVisible(false)
        self.save_btn:setVisible(true)
    end
    --策划要求不管什么类型的战斗都显示一键上阵按钮
    self.key_up_btn:setVisible(true)
end

--显示根据当前选择阵型筛选英雄 0表示全部阵型
function GW_EmbattleWindow:onClickBtnShowByIndex(select_camp)
    for i,v in pairs(self.camp_btn_list) do
        v.select:setVisible(false)
    end
    self.camp_btn_list[select_camp].select:setVisible(true)

    --if self.img_select and self.camp_btn_list[select_camp] then
    --    local selectSpriteName = "gw_hero_head_camptype_selected"
    --    if select_camp == HeroConst.CampType.eNone then
    --        selectSpriteName = "gw_hero_head_camptype_all_selected"
    --    end
    --    local select_res = PathTool.getResFrame("gw_hero_head", selectSpriteName)
    --    loadSpriteTexture(self.img_select, select_res, LOADTEXT_TYPE_PLIST)
    --    local x, y = self.camp_btn_list[select_camp]:getPosition()
    --    self.img_select:setPosition(x, y)
    --end

    self:updateHeroList(select_camp)
end

--灰化阵营按钮
function GW_EmbattleWindow:setCampBtnUnEnabled(list)
    if list and next(list) ~= nil and self.camp_btn_list and next(self.camp_btn_list) ~= nil then
        for k,v in pairs(list) do
            if self.camp_btn_list[v] then
                setChildUnEnabled(true, self.camp_btn_list[v])
                self.camp_btn_list[v]:setTouchEnabled(false)
            end
        end
    end
end

--创建英雄列表
-- @select_camp 选中阵营
function GW_EmbattleWindow:updateHeroList(select_camp, must_reset)
    local select_camp = select_camp or 0
    if not must_reset and select_camp == self.select_camp then
        return
    end
    if not self.list_view then
        local setting = {
            -- item_class = HeroExhibitionItem,      -- 单元类
            start_x = 24,                  -- 第一个单元的X起点
            space_x = 14,                    -- x方向的间隔
            start_y = 29,                    -- 第一个单元的Y起点
            space_y = 0,                   -- y方向的间隔
            item_width = 112,               -- 单元的尺寸width
            item_height = 134,              -- 单元的尺寸height
            row = 1,                        -- 行数，作用于水平滚动类型
            --col = 5,                         -- 列数，作用于垂直滚动类型
            need_dynamic = true
        }
        local size = self.list_container:getContentSize()
        self.list_view = CommonScrollViewSingleLayout.new(self.list_container, cc.p(0, 0) , ScrollViewDir.horizontal, ScrollViewStartPos.top, size, setting, cc.p(0,0))
        self.list_view:registerScriptHandlerSingle(handler(self,self.createNewCell), ScrollViewFuncType.CreateNewCell) --创建cell
        self.list_view:registerScriptHandlerSingle(handler(self,self.numberOfCells), ScrollViewFuncType.NumberOfCells) --获取数量
        self.list_view:registerScriptHandlerSingle(handler(self,self.updateCellByIndex), ScrollViewFuncType.UpdateCellByIndex) --更新cell
        --self.list_view.scroll_view:setScrollBarEnabled(true)
        --self.list_view.scroll_view:setScrollBarAutoHideEnabled(false)
        --
        --local bar_position = self.list_view.scroll_view:getScrollBarPositionFromCornerForHorizontal()
        --bar_position.y = bar_position.y - 15
        --self.list_view.scroll_view:setScrollBarPositionFromCornerForHorizontal(bar_position)
        --self.list_view.scroll_view:setScrollBarWidth(4)
        --self.list_view.scroll_view:setScrollBarColor(cc.c3b(0xbc,0xbc,0xbc))
    end
    -- 引导中不给滑动列表
    if GuideController:getInstance():isInGuide() then
        self.list_view:setClickEnabled(false)
    end

    self.select_camp = select_camp
    --英雄列表 (默认)
    local hero_array = model:getAllHeroArray()
    local vo = Array.New()

    local temp_power = 0
    for j=1,hero_array:GetSize() do
        local hero_vo = hero_array:Get(j-1)
        if select_camp == 0 or (select_camp == hero_vo.camp_type) then
            hero_vo.is_in_team = 0
            vo:PushBack(hero_vo)
        end
        if self.fun_form_type == PartnerConst.Fun_Form.EndLessLightDark and hero_vo and (hero_vo.camp_type == HeroConst.CampType.eLight or hero_vo.camp_type == HeroConst.CampType.eDark) then
            if hero_vo and temp_power < hero_vo.power then
                temp_power = hero_vo.power
            end
        elseif select_camp == 0 or (select_camp == hero_vo.camp_type) then
            if hero_vo and temp_power < hero_vo.power then
                temp_power = hero_vo.power
            end
        end
    end

    if self.fun_form_type == PartnerConst.Fun_Form.EndLess or
            self.fun_form_type == PartnerConst.Fun_Form.EndLessWater or
            self.fun_form_type == PartnerConst.Fun_Form.EndLessFire or
            self.fun_form_type == PartnerConst.Fun_Form.EndLessWind or
            self.fun_form_type == PartnerConst.Fun_Form.EndLessSoil or
            self.fun_form_type == PartnerConst.Fun_Form.EndLessLightDark then
        local list = self.setting.has_hire_list or {}
        local partner_config = Config.PartnerData.data_partner_base
        for i,v in ipairs(list) do
            if (temp_power and v.power <= temp_power*1.2) or self.fun_form_type == PartnerConst.Fun_Form.EndLess then
                local config  = partner_config[v.bid]
                if select_camp == 0 or (select_camp == config.camp_type) then
                    v.partner_id = v.id
                    v.camp_type = config.camp_type
                    v.is_endless = true --是否无尽试炼雇佣兵
                    --table_insert(show_list,1,v)
                    v.is_in_team = 0
                    vo:PushBack(v)
                end

                --Debug.info(v)
            end
        end
    end

    --设置已上阵英雄排在前面
    for i,v in pairs(self.six_hero_vo) do
        v.is_in_team = 10-i
    end


    vo:UpperSortByParams("is_in_team", "star","power","lev","sort_order")

    local show_list = vo.items

    self.show_list = show_list
    self.list_view:reloadData()
end

--创建cell
--@width 是setting.item_width
--@height 是setting.item_height
function GW_EmbattleWindow:createNewCell(width, height)
    local cell = GW_EmbattleHeroItem.new(1, true, 0, true)
    cell.is_not_show_redpoint = true
    if self.fun_form_type == PartnerConst.Fun_Form.Expedit_Fight then  --远征
        cell.from_type = HeroConst.ExhibitionItemType.eExpeditFight
        cell.boold_type = true
    elseif self.fun_form_type == PartnerConst.Fun_Form.EndLess or
            self.fun_form_type == PartnerConst.Fun_Form.EndLessWater or
            self.fun_form_type == PartnerConst.Fun_Form.EndLessFire or
            self.fun_form_type == PartnerConst.Fun_Form.EndLessWind or
            self.fun_form_type == PartnerConst.Fun_Form.EndLessSoil or
            self.fun_form_type == PartnerConst.Fun_Form.EndLessLightDark then -- 无尽试炼
        cell.from_type = HeroConst.ExhibitionItemType.eEndLessHero
    elseif self.fun_form_type == PartnerConst.Fun_Form.LimitExercise then  --试炼之境
        cell.from_type = HeroConst.ExhibitionItemType.eLimitExercise
    elseif self.fun_form_type == PartnerConst.Fun_Form.Planes then  --位面
        cell.from_type = HeroConst.ExhibitionItemType.ePlanes
    else --剧情布阵
        cell.from_type = HeroConst.ExhibitionItemType.eFormFight
    end
    cell:setLongTimeTouchEffect(true)
    cell:addCallBack(function() self:onCellTouched(cell) end)
    return cell
end

--获取数据数量
function GW_EmbattleWindow:numberOfCells()
    if not self.show_list then return 0 end
    return #self.show_list
end

--更新cell(拖动的时候.刷新数据时候会执行次方法)
--cell :createNewCell的返回的对象
--inde :数据的索引
function GW_EmbattleWindow:updateCellByIndex(cell, index)
    cell.index = index
    local hero_vo = self.show_list[index]
    cell:setData(hero_vo)
    --cell:setName("hero_" .. hero_vo.partner_id)
    --print("hero_" .. hero_vo.partner_id)
    print(cell:getName())
    ----设置是否已上阵
    --cell:setSelected(hero_vo.is_ui_select == true)
end

--点击cell .需要在 createNewCell 设置点击事件
function GW_EmbattleWindow:onCellTouched(cell)
    local index = cell.index
    local hero_vo = self.show_list[index]
    if hero_vo then
        self:selectHero(cell, hero_vo)
    end
end
--@hero_vo 英雄数据
function GW_EmbattleWindow:selectHero(item, hero_vo)
    if not self.is_form_back then return end
    if not hero_vo  then return end
    if not item then return end
    --图标飞行中
    if self.is_play_item_action then return end

    if hero_vo.is_ui_select then
        hero_vo.is_ui_select = nil
        for i=1,9 do
            if self.six_hero_vo[i] ~= nil and self.six_hero_vo[i].id == hero_vo.id and self.six_hero_vo[i].partner_id == hero_vo.partner_id then
                self.six_hero_vo[i] = nil

                --结束位置
                local world_pos = item:convertToWorldSpace(cc.p(GW_HeroSpineItem.Width * 0.5, GW_HeroSpineItem.Height * 0.5))
                local end_pos = self.fight_hero_node:convertToNodeSpace(world_pos)
                local x, y =  self.hero_item_list[i]:getPosition()
                self:showMoveEffect(cc.p(x,y), end_pos, hero_vo)
                break
            end
        end

        self:updateSixHeroItem()
    else
        local count = 0
        for i,v in pairs(self.six_hero_vo) do
            count = count + 1
        end
        if count >= 6 then
            message(UI_TI18N(32003))
            return
        end

        for i,v in pairs(self.six_hero_vo) do
            if v.bid == hero_vo.bid then
                message(UI_TI18N(32011))
                return
            end
        end

        --for i=1,9 do
        --    if self.six_hero_vo[i] ~= nil and self.six_hero_vo[i].bid == hero_vo.bid then
        --        message(TI18N("不能同时上阵2个相同英雄"))
        --        return
        --    end
        --end

        if self.gw_cur_up_pos == nil or self.six_hero_vo[self.gw_cur_up_pos] ~= nil then
            for i=1,9 do
                if self.six_hero_vo[i] == nil then
                    self.six_hero_vo[i] = hero_vo
                    break;
                end
            end
        else
            self.six_hero_vo[self.gw_cur_up_pos] = hero_vo
        end

        self:updateSixHeroItem()

    end

    --更新战力显示
    self:updateFightPower()
    --更新阵营
    self:updateHallowsIcon()
    --更新阵型触发属性
    self:calculateCampHaloType()
end

--设置英雄已经被选中
function GW_EmbattleWindow:setHeroIsSelect()
    --清空选中状态
    local hero_list = model:getHeroList()
    for k, hero_vo in pairs(hero_list) do
        hero_vo.is_ui_select = nil
    end

    --设置当前上阵伙伴选中
    for i,v in pairs(self.six_hero_vo) do
        v.is_ui_select = true
    end
end

--其他布阵信息
function GW_EmbattleWindow:initFormInfo(data)
    self.team_data = data
    --是否布阵网络信息返回
    self.is_form_back = true
    self.formation_type = data.formation_type
    self.hallows_id = data.hallows_id or 1

    if not data then return end

    if self.six_hero_vo ~= nil then
        self.six_hero_vo = nil
    end
    self.six_hero_vo = {}
    for i,info in pairs(self.team_data.pos_info or {}) do
        local hero_vo = model:getHeroById(info.id)
        self.six_hero_vo[info.pos] = hero_vo
    end

    if self.first_sort == nil then
        self.first_sort = true
        --英雄列表 (默认)
        local hero_array = model:getAllHeroArray()
        local vo = Array.New()

        local temp_power = 0
        for j=1,hero_array:GetSize() do
            local hero_vo = hero_array:Get(j-1)
            if self.select_camp == 0 or (self.select_camp == hero_vo.camp_type) then
                hero_vo.is_in_team = 0
                vo:PushBack(hero_vo)
            end

            if self.fun_form_type == PartnerConst.Fun_Form.EndLessLightDark and hero_vo and (hero_vo.camp_type == HeroConst.CampType.eLight or hero_vo.camp_type == HeroConst.CampType.eDark) then
                if hero_vo and temp_power < hero_vo.power then
                    temp_power = hero_vo.power
                end
            elseif self.select_camp == 0 or (self.select_camp == hero_vo.camp_type) then
                if hero_vo and temp_power < hero_vo.power then
                    temp_power = hero_vo.power
                end
            end
        end

        if self.fun_form_type == PartnerConst.Fun_Form.EndLess or
                self.fun_form_type == PartnerConst.Fun_Form.EndLessWater or
                self.fun_form_type == PartnerConst.Fun_Form.EndLessFire or
                self.fun_form_type == PartnerConst.Fun_Form.EndLessWind or
                self.fun_form_type == PartnerConst.Fun_Form.EndLessSoil or
                self.fun_form_type == PartnerConst.Fun_Form.EndLessLightDark then
            local list = self.setting.has_hire_list or {}
            local partner_config = Config.PartnerData.data_partner_base
            for i,v in ipairs(list) do
                if (temp_power and v.power <= temp_power*1.2) or self.fun_form_type == PartnerConst.Fun_Form.EndLess then
                    local config  = partner_config[v.bid]
                    if self.select_camp == 0 or (self.select_camp == config.camp_type) then
                        v.partner_id = v.id
                        v.camp_type = config.camp_type
                        v.is_endless = true --是否无尽试炼雇佣兵
                        --table_insert(show_list,1,v)
                        v.is_in_team = 0
                        vo:PushBack(v)
                    end
                end
            end
        end

        --设置已上阵英雄排在前面
        for i,v in pairs(self.six_hero_vo) do
            v.is_in_team = 10-i
        end

        vo:UpperSortByParams("is_in_team", "star","power","lev","sort_order")

        local show_list = vo.items

        self.show_list = show_list
        self.list_view:reloadData()
    end

    --更新阵中6个英雄信息
    self:updateSixHeroItem(false)
    --更新战力显示
    self:updateFightPower()
    --更新阵法元素信息
    self:updateHallowsIcon()
    --更新阵型触发属性
    self:calculateCampHaloType()


    ---- 开启计时器,准备创建英雄模型
    --local index = 1
    --if self.hero_item_list_timer ~= nil then
    --    GlobalTimeTicket:getInstance():remove(self.hero_item_list_timer)
    --    self.hero_item_list_timer = nil
    --end
    --if self.hero_item_list_timer == nil then
    --    self.hero_item_list_timer = GlobalTimeTicket:getInstance():add(function()
    --        if self.six_hero_vo then
    --            if self.six_hero_vo[index] == nil then
    --                self.hero_item_list[index]:setData(nil)
    --            else
    --                self.hero_item_list[index]:setData(self.six_hero_vo[index])
    --            end
    --        end
    --
    --        index = index + 1
    --    end, 0.05,9)
    --end
end

--更新6个英雄信息
function GW_EmbattleWindow:updateSixHeroItem(model_flag)
    --设置列表伙伴选中
    self:setHeroIsSelect()
    if model_flag == nil or model_flag == true then
        for i,item in ipairs(self.hero_item_list) do
            if self.six_hero_vo then
                if self.six_hero_vo[i] == nil then
                    item:setData(nil)
                else
                    item:setData(self.six_hero_vo[i])
                end
            end
        end
    else
        local index = 1
        for i,item in ipairs(self.hero_item_list) do
            if self.six_hero_vo then
                if self.six_hero_vo[i] == nil then
                    item:setData(nil)
                else
                    if self.is_init_hero then
                        delayRun(self.root_wnd, 2*index/display.DEFAULT_FPS, function()
                            item:setData(self.six_hero_vo[i])
                        end)
                    else
                        item:setData(self.six_hero_vo[i])
                    end

                    index = index + 1
                end
            end
        end

        self.is_init_hero = false
    end
    if self.list_view then
        self.list_view:resetCurrentItems()
    end
end
--设置英雄已经被选中
function GW_EmbattleWindow:setHeroIsSelect()
    --清空选中状态
    local hero_list = model:getHeroList()
    for k, hero_vo in pairs(hero_list) do
        hero_vo.is_ui_select = nil
    end

    --设置当前上阵伙伴选中
    for i,v in pairs(self.six_hero_vo) do
        v.is_ui_select = true
    end
end

--刷新阵法元素显示
function GW_EmbattleWindow:updateHallowsIcon()

    if self.hallows_id == 0 then
        self.hallow_info_icon:setVisible(false)
    else
        local hallows_config = Config.HallowsData.data_base[self.hallows_id]
        if hallows_config then
            local hallows_vo = HallowsController:getInstance():getModel():getHallowsById(self.hallows_id)
            if hallows_vo and hallows_vo.look_id ~= 0 then
                local magic_cfg = Config.HallowsData.data_magic[hallows_vo.look_id]
                if magic_cfg then
                    local magic_item_config = Config.ItemData.data_get_data(magic_cfg.item_id)
                    local head_icon = PathTool.getItemRes(magic_item_config.icon, false)
                    loadSpriteTexture(self.hallow_info_icon, head_icon, LOADTEXT_TYPE)
                    --self.hallows_item:setBaseData(magic_cfg.item_id)
                    --self.hallows_item:setMagicIcon(true)
                else
                    local magic_item_config = Config.ItemData.data_get_data(hallows_config.item_id)
                    local head_icon = PathTool.getItemRes(magic_item_config.icon, false)
                    loadSpriteTexture(self.hallow_info_icon, head_icon, LOADTEXT_TYPE)
                    --self.hallows_item:setBaseData(hallows_config.item_id)
                    --self.hallows_item:setMagicIcon(false)
                end
            else
                local magic_item_config = Config.ItemData.data_get_data(hallows_config.item_id)
                local head_icon = PathTool.getItemRes(magic_item_config.icon, false)
                loadSpriteTexture(self.hallow_info_icon, head_icon, LOADTEXT_TYPE)
                --self.hallows_item:setBaseData(hallows_config.item_id)
                --self.hallows_item:setMagicIcon(false)
            end

            self.hallow_info_icon:setVisible(true)
        else
            self.hallow_info_icon:setVisible(false)
        end
    end

    if self.form_type_colors == nil then return end

    for i,v in pairs(self.form_type_colors) do
        v:setVisible(false)
    end
    --for i,halo_icon in pairs(self.form_type_colors or {}) do
    --    halo_icon:setVisible(false)
    --end

    local pos = 1
    for i=1,9 do
        if self.six_hero_vo ~= nil and self.six_hero_vo[i] ~= nil then
            --local res = PathTool.gw_getHeroFormTypeIcon(self.six_hero_vo[i].camp_type)
            --self.form_type_colors[pos]:loadTexture(res, LOADTEXT_TYPE_PLIST)
            --self.form_type_colors[pos]:setVisible(true)

            local res = PathTool.getResFrame("gw_embattle", "gw_embattle_2_ele_shui")
            if self.six_hero_vo[i].camp_type == HeroConst.CampType.eWater then --水
                res = PathTool.getResFrame("gw_embattle", "gw_embattle_2_ele_shui")
            elseif self.six_hero_vo[i].camp_type == HeroConst.CampType.eFire then --火
                res = PathTool.getResFrame("gw_embattle", "gw_embattle_2_ele_huo")
            elseif self.six_hero_vo[i].camp_type == HeroConst.CampType.eWind then --风
                res = PathTool.getResFrame("gw_embattle", "gw_embattle_2_ele_feng")
            elseif self.six_hero_vo[i].camp_type == HeroConst.CampType.eLight then --光
                res = PathTool.getResFrame("gw_embattle", "gw_embattle_2_ele_huang")
            elseif self.six_hero_vo[i].camp_type == HeroConst.CampType.eDark then --暗
                res = PathTool.getResFrame("gw_embattle", "gw_embattle_2_ele_an")
            elseif self.six_hero_vo[i].camp_type == HeroConst.CampType.eSoil then --土
                res = PathTool.getResFrame("gw_embattle", "gw_embattle_2_ele_tu")
            end
            loadSpriteTexture(self.form_type_colors[pos], res, LOADTEXT_TYPE_PLIST)
            self.form_type_colors[pos]:setVisible(true)

            pos = pos + 1
            if pos > 6 then
                break
            end
        end
    end

    self:updateNextUpPosShow()
end

--显示移动效果
--@start_pos 开始位置
--@end_pos 结束位置
function GW_EmbattleWindow:showMoveEffect(start_pos, end_pos, hero_vo, callback)
    self.is_play_item_action = true
    if self.move_hero_item == nil then
        self.move_hero_item = GW_HeroSpineItem.new(1, false)
        self.fight_hero_node:addChild(self.move_hero_item, 15)
    end
    self.move_hero_item:setData(hero_vo)
    self.move_hero_item:setPosition(start_pos)
    local action1 = cc.MoveTo:create(0.2, end_pos)
    local callfunc = cc.CallFunc:create(function()
        if self.move_hero_item then
            self.move_hero_item:setPosition(-10000, 0)
        end
        self.is_play_item_action = false
        if callback then
            callback()
        end
    end)
    self.move_hero_item:runAction(cc.Sequence:create(action1,callfunc))
end

--刷新总战力
function GW_EmbattleWindow:updateFightPower()
    if self.power_infos_num == nil then return end

    --总战力
    local totalBattle = 0

    --当前上阵英雄数量
    local totalNum = 0

    local flag = false
    if self.six_hero_vo ~= nil then
        for i=1,9 do
            if self.six_hero_vo[i] ~= nil and self.six_hero_vo[i].power ~= nil then
                totalBattle = totalBattle + self.six_hero_vo[i].power

                totalNum = totalNum + 1
            end
        end
    end

    --self.up_num_label:setString(totalNum)
    --self.total_battle:setNum(totalBattle)

    self.num_infos_label_2:setString(totalNum)
    self.num_infos_label_3:setPositionX(self.num_infos_label_2:getPositionX() + self.num_infos_label_2:getContentSize().width)
    self.power_infos_num:setNum(totalBattle)
end

--计算阵型触发属性
function GW_EmbattleWindow:calculateCampHaloType()
    if self.form_type_attr_list == nil then return end
    for i,v in pairs(self.form_type_attr_list) do
        v:setVisible(false)
    end

    if not self.six_hero_vo then return end
    local dic_camp = {}
    for i,v in pairs(self.six_hero_vo) do
        if v ~= nil and v.camp_type ~= nil then
            if dic_camp[v.camp_type] == nil then
                dic_camp[v.camp_type] = 1
            else
                dic_camp[v.camp_type] = dic_camp[v.camp_type] + 1
            end
        end
    end

    self.halo_form_id_list = BattleController:getInstance():getModel():getFormIdListByCamp(dic_camp)

    local attr_list = {}
    for k,form_id in pairs(self.halo_form_id_list) do
        local form_cfg = Config.CombatHaloData.data_halo[form_id]
        if form_cfg and form_cfg.attrs and next(form_cfg.attrs) ~= nil then
            for _,v in pairs(form_cfg.attrs) do
                local is_have = false
                for _,attr in pairs(attr_list) do
                    if attr[1] == v[1] then
                        is_have = true
                        attr[2] = attr[2] + v[2]
                        break
                    end
                end
                if not is_have then
                    table_insert(attr_list, deepCopy(v))
                end
            end
        end
    end

    if next(attr_list) == nil then
        --self.all_attr_txt:setString(TI18N("未激活阵营光环"))
    else
        --local posX = 5
        --local attr_str = ""
        for i,v in ipairs(attr_list) do
            local attr_key = v[1]
            local attr_val = v[2]/1000
            --local attr_name = Config.AttrData.data_key_to_name[attr_key]
            if attr_key then
                local is_per = PartnerCalculate.isShowPerByStr(attr_key)
                if is_per == true then
                    attr_val = (attr_val*100).."%"
                end
                ----if i == 1 then
                ----    attr_str = attr_str .. _string_format("%s<div fontcolor=#68c74b>+%s</div>", attr_name, attr_val)
                ----else
                ----    attr_str = attr_str .. _string_format("  %s<div fontcolor=#68c74b>+%s</div>", attr_name, attr_val)
                ----end
                --
                --if self.halo_form_attr_list[i] == nil then
                --    self.halo_form_attr_list[i] = {}
                --    self.halo_form_attr_list[i].icon = createImage(self.form_attrs_node,nil,0,0,cc.p(1,0.5),true,1,false)
                --    self.halo_form_attr_list[i].label = createLabel(20,cc.c4b(0xff,0xff,0xff,0xff),cc.c4b(0x00,0x00,0x00,0xaa),-5,17,"",self.halo_form_attr_list[i].icon,1, cc.p(1,0.5))
                --    self.halo_form_attr_list[i].label:setZOrder(6)
                --end
                --
                --self.halo_form_attr_list[i].icon:loadTexture( PathTool.gw_getAttrIconRes(attr_key), LOADTEXT_TYPE_PLIST)
                --self.halo_form_attr_list[i].label:setString("+"..attr_val)
                --self.halo_form_attr_list[i].icon:setPositionX(posX)
                --self.halo_form_attr_list[i].icon:setVisible(true)
                --
                --posX = posX - 37 - self.halo_form_attr_list[i].label:getContentSize().width - 15

                PathTool.gw_setAttrIcon(self.form_type_attr_list[i].icon, attr_key)
                self.form_type_attr_list[i].label:setString("+"..attr_val)
                self.form_type_attr_list[i]:setVisible(true)

                if i >= #self.form_type_attr_list then
                    break
                end
            end
        end
    end
end

--刷新阵容切换按钮状态
function GW_EmbattleWindow:updateFormationChangeBtnStatus()
    if self.show_type == HeroConst.FormShowType.eFormSave then
        self.formation_change_btn:setVisible(false)

        for i,v in pairs(self.formation_choose_list) do
            if v.fun_form_type == self.fun_form_type then
                local str = string.format("<div fontColor=#e7e6e6 fontsize=28>%s</div>", self.formation_choose_name_list[i])
                StringUtil.gw_setLabelContent(self.formation_change_btn_label, str, 160)
                self.formation_change_btn:setVisible(true)
                break
            end
        end
    else
        self.formation_change_btn:setVisible(false)
    end
end
--显示阵容选择面板
function GW_EmbattleWindow:showFormationChoosePanel()
    self.formation_choose_panel:setVisible(not self.formation_choose_panel:isVisible())
end
--更新下一个上阵位置
function GW_EmbattleWindow:updateNextUpPosShow()
    for i,v in pairs(self.spine_infos_pos_bg_list) do
        v:setVisible(self.six_hero_vo[i] ~= nil)
    end

    local count = 0
    for i=1,9 do
        if self.six_hero_vo[i] ~= nil then
            count = count + 1
            if count >= 6 then
                self.gw_cur_up_pos = nil
                return
            end
        end
    end

    if self.gw_cur_up_pos ~= nil then
        if self.six_hero_vo[self.gw_cur_up_pos] ~= nil then
            self.gw_cur_up_pos = nil
        end
    end

    if self.gw_cur_up_pos == nil then
        for i=1,9 do
            if self.six_hero_vo[i] == nil then
                self.gw_cur_up_pos = i
                break
            end
        end
    end

    if self.gw_cur_up_pos ~= nil then
        self.spine_infos_pos_bg_list[self.gw_cur_up_pos]:setVisible(true)
    end
end
--穿戴神器
function GW_EmbattleWindow:onClickEquipBtn()
    if not self.hallows_id then return end

    if model.is_redpoint_hallows then
        model.is_redpoint_hallows = false
        self.hallow_info_redpoint:setVisible(false)
    end

    local dic_equips = {}
    if self.hallows_id and self.hallows_id ~= 0 then
        dic_equips[self.hallows_id] = 1
    end

    controller:openFormHallowsSelectPanel(true, self.hallows_id, function(hallows_id, team_index)
        if hallows_id then
            if team_index == self.fun_form_type then
                self.hallows_id = hallows_id
                self:updateHallowsIcon()
            end
        end
    end, dic_equips, self.fun_form_type)
end

--更新敌方信息
function GW_EmbattleWindow:updateEnemyInfo(data)
    self.enemy_data = data
    if self.enemy_data == nil then
        self.enemy_infos:setVisible(false)
        self.enemy_detail_panel:setVisible(false)
    else
        if self.enemy_infos_detail_btn == nil then
            self.enemy_infos_detail_btn = self.enemy_infos:getChildByName("detail_btn")
            self.enemy_infos_detail_btn:addTouchEventListener(function(sender, event_type)
                --customClickAction_4(sender, event_type)
                if event_type == ccui.TouchEventType.ended then
                    playButtonSound2()
                    self:showEnemyDetailPanel()
                end
            end)
            self.enemy_infos:getChildByName("name"):setString(UI_TI18N(32012))
            self.enemy_infos_power_icon = self.enemy_infos:getChildByName("power_icon")
            self.enemy_infos_power = self.enemy_infos:getChildByName("power")
            self.enemy_infos_pos_list = {}
            for i=1,9 do
                self.enemy_infos_pos_list[i] = self.enemy_infos:getChildByName("pos"..i)
                self.enemy_infos_pos_list[i].icon = self.enemy_infos_pos_list[i]:getChildByName("icon")
            end
        end

        self.enemy_infos_power:setString(self.enemy_data.power)
        self.enemy_infos_power_icon:setPositionX(-94 - (self.enemy_infos_power:getContentSize().width + 35)/2)
        self.enemy_infos_power:setPositionX(self.enemy_infos_power_icon:getPositionX() + 35)
        for i,v in pairs(self.enemy_infos_pos_list) do
            v:setVisible(false)
        end
        if self.enemy_data.object_list ~= nil and next(self.enemy_data.object_list) ~= nil then
            for i,v in pairs(self.enemy_data.object_list) do
                local pos = v.pos
                local item = self.enemy_infos_pos_list[pos]
                if item ~= nil then
                    item.id = v.id

                    if self.fun_form_type == PartnerConst.Fun_Form.Drama then
                        local config = Config.UnitData.data_unit(v.id)
                        if config ~= nil then
                            loadSpriteTexture(item.icon, PathTool.gw_getCampTypeCommon01(config.camp_type), LOADTEXT_TYPE_PLIST)
                        else
                            Debug.error("找不到怪物配置！！！ID:"..v.id)
                        end
                    elseif self.fun_form_type == PartnerConst.Fun_Form.Startower then
                        local config = Config.UnitData.data_unit(v.id)
                        if config ~= nil then
                            loadSpriteTexture(item.icon, PathTool.gw_getCampTypeCommon01(config.camp_type), LOADTEXT_TYPE_PLIST)
                        else
                            Debug.error("找不到怪物配置！！！ID:"..v.id)
                        end
                    else
                        local base_config = Config.PartnerData.data_partner_base_fun(v.id)
                        if base_config ~= nil then
                            loadSpriteTexture(item.icon, PathTool.gw_getCampTypeCommon01(base_config.camp_type), LOADTEXT_TYPE_PLIST)
                        else
                            Debug.error("找不到英雄配置！！！ID:"..v.id)
                        end
                    end

                    item:setVisible(true)
                end
            end
        end

        self.enemy_infos:setVisible(true)
        self.enemy_detail_panel:setVisible(false)
    end
end
--显示敌方详细信息
function GW_EmbattleWindow:showEnemyDetailPanel()
    if self.enemy_data == nil then
        self.enemy_detail_panel:setVisible(false)
        return
    end

    if self.enemy_detail_panel_main_container == nil then
        self.enemy_detail_panel_background = self.enemy_detail_panel:getChildByName("background")
        self.enemy_detail_panel_background:addTouchEventListener(function(sender, event_type)
            --customClickAction(sender, event_type)
            if event_type == ccui.TouchEventType.ended then
                playButtonSound2()
                self.enemy_detail_panel:setVisible(false)
            end
        end)
        self.enemy_detail_panel_background:setScale(display.getMaxScale())
        self.enemy_detail_panel_main_container = self.enemy_detail_panel:getChildByName("main_container")
        self.enemy_detail_panel_main_container:setPositionX(display.getRight())
        self.enemy_detail_panel_main_container:setPositionY(display.getTop() - 86)
        self.enemy_detail_panel_main_container:getChildByName("name"):setString(UI_TI18N(32012))
        self.enemy_detail_panel_power_icon = self.enemy_detail_panel_main_container:getChildByName("power_icon")
        self.enemy_detail_panel_power = self.enemy_detail_panel_main_container:getChildByName("power")
        self.enemy_detail_panel_pos_list = {}
        for i=1,9 do
            self.enemy_detail_panel_pos_list[i] = self.enemy_detail_panel_main_container:getChildByName("pos"..i)
            self.enemy_detail_panel_pos_list[i].item_node = self.enemy_detail_panel_pos_list[i]:getChildByName("item_node")
            self.enemy_detail_panel_pos_list[i].label = self.enemy_detail_panel_pos_list[i]:getChildByName("label")
            self.enemy_detail_panel_pos_list[i].label:setString(i)
            self.enemy_detail_panel_pos_list[i]:setVisible(false)
        end
    end

    for i,v in pairs(self.enemy_detail_panel_pos_list) do
        v:setVisible(false)
    end
    if self.enemy_data.object_list ~= nil and next(self.enemy_data.object_list) ~= nil then
        for i,v in pairs(self.enemy_data.object_list) do
            local pos = v.pos
            local item = self.enemy_detail_panel_pos_list[pos]
            if item ~= nil then
                item.id = v.id
                if item.hero_item == nil then
                    item.hero_item = GW_HeroTempleSacrificeInfoListItem.new()
                    item.hero_item.icon:setFlipX(true)
                    item.hero_item:setScale(0.73)
                    item.item_node:addChild(item.hero_item)
                end


                if self.fun_form_type == PartnerConst.Fun_Form.Drama then
                    if self.setting ~= nil and self.setting.combat_sub_type ~= nil then
                        if self.setting.combat_sub_type == BattleConst.Drama_Sub_Type.Drama then
                            local config = Config.UnitData.data_unit(v.id)
                            if config ~= nil then
                                item.hero_item:setData({lev = v.lev, star = config.star, camp_type = config.camp_type, bid =v.id})
                                item.hero_item.lev:setString(string.format("Lv.%d", v.lev))
                                item.hero_item:setHeadImg(config.head_icon)
                            else
                                Debug.error("找不到怪物配置！！！ID:"..v.id)
                            end
                        elseif self.setting.combat_sub_type == BattleConst.Drama_Sub_Type.Branch then
                            local config = Config.UnitData.data_unit(v.id)
                            if config ~= nil then
                                item.hero_item:setData({lev = v.lev, star = config.star, camp_type = config.camp_type, bid =v.id})
                                item.hero_item.lev:setString(string.format("Lv.%d", v.lev))
                                item.hero_item:setHeadImg(config.head_icon)
                            else
                                Debug.error("找不到怪物配置！！！ID:"..v.id)
                            end
                        elseif self.setting.combat_sub_type == BattleConst.Drama_Sub_Type.Free then
                            local config = Config.UnitData.data_unit(v.id)
                            if config ~= nil then
                                item.hero_item:setData({lev = v.lev, star = config.star, camp_type = config.camp_type, bid =v.id})
                                item.hero_item.lev:setString(string.format("Lv.%d", v.lev))
                                item.hero_item:setHeadImg(config.head_icon)
                            else
                                Debug.error("找不到怪物配置！！！ID:"..v.id)
                            end
                        elseif self.setting.combat_sub_type == BattleConst.Drama_Sub_Type.StoneDungeon then
                            local config = Config.UnitData.data_unit(v.id)
                            if config ~= nil then
                                item.hero_item:setData({lev = v.lev, star = config.star, camp_type = config.camp_type, bid =v.id})
                                item.hero_item.lev:setString(string.format("Lv.%d", v.lev))
                                item.hero_item:setHeadImg(config.head_icon)
                            else
                                Debug.error("找不到怪物配置！！！ID:"..v.id)
                            end
                        else
                            local config = Config.UnitData.data_unit(v.id)
                            if config ~= nil then
                                item.hero_item:setData({lev = v.lev, star = config.star, camp_type = config.camp_type, bid =v.id})
                                item.hero_item.lev:setString(string.format("Lv.%d", v.lev))
                                item.hero_item:setHeadImg(config.head_icon)
                            else
                                Debug.error("找不到怪物配置！！！ID:"..v.id)
                            end
                        end
                    else
                        local config = Config.UnitData.data_unit(v.id)
                        if config ~= nil then
                            item.hero_item:setData({lev = v.lev, star = config.star, camp_type = config.camp_type, bid =v.id})
                            item.hero_item.lev:setString(string.format("Lv.%d", v.lev))
                            item.hero_item:setHeadImg(config.head_icon)
                        else
                            Debug.error("找不到怪物配置！！！ID:"..v.id)
                        end
                    end
                elseif self.fun_form_type == PartnerConst.Fun_Form.Startower then
                    local config = Config.UnitData.data_unit(v.id)
                    if config ~= nil then
                        item.hero_item:setData({lev = v.lev, star = config.star, camp_type = config.camp_type, bid =v.id})
                        item.hero_item.lev:setString(string.format("Lv.%d", v.lev))
                        item.hero_item:setHeadImg(config.head_icon)
                    else
                        Debug.error("找不到怪物配置！！！ID:"..v.id)
                    end
                else
                    local base_config = Config.PartnerData.data_partner_base_fun(v.id)
                    if base_config ~= nil then
                        item.hero_item:setData({lev = v.lev, star = v.star, camp_type = config.camp_type, bid =v.id})
                        item.hero_item.lev:setString(string.format("Lv.%d", v.lev))
                    else
                        Debug.error("找不到英雄配置！！！ID:"..v.id)
                    end
                end


                item:setVisible(true)
            end
        end
    end

    self.enemy_detail_panel_power:setString(self.enemy_data.power)
    self.enemy_detail_panel_power_icon:setPositionX(183 - (self.enemy_detail_panel_power:getContentSize().width + 35)/2)
    self.enemy_detail_panel_power:setPositionX(self.enemy_detail_panel_power_icon:getPositionX() + 35)

    self:playEnterAnimatianByObj(self.enemy_detail_panel_main_container , 3)
    self.enemy_detail_panel:setVisible(true)
end

function GW_EmbattleWindow:initEflinInfoList(data)
    if self.fun_form_type == PartnerConst.Fun_Form.Drama then
        if self.fun_form_type == data.type then
            if self.fun_form_type == PartnerConst.Fun_Form.CrossArenaDef or  -- 跨服竞技场
                    self.fun_form_type == PartnerConst.Fun_Form.ArenapeakchampionDef then --巅峰冠军赛
                --todo
                --self.elfin_team_data_list[v.index] = {}
                --local old_order
                --if self.team_data_list[self.select_team_index] then
                --    old_order = self.team_data_list[self.select_team_index].old_order
                --end
                --local index_temp = self.team_select_team_index or 1
                --local cur_index = old_order or (index_temp - 1)
                --
                --for i,team_data in ipairs(data.team_list) do
                --    self.elfin_team_data_list[v.index][team_data.team + 1] = team_data
                --    if cur_index == team_data.team then
                --        self:updateElfinList(team_data)
                --    end
                --end
                --for i=2,4 do
                --    if self.elfin_team_data_list[v.index][i] == nil then
                --        self.elfin_team_data_list[v.index][i] = self:getDefaultTeamInfo(i - 1)
                --    end
                --end
            else
                self:updateElfinList(data.team_list[1])
                --self.elfin_team_data_list[v.index] = data.team_list[1]
                --if self.select_team_index == v.index then
                --    self:updateElfinList(self.elfin_team_data_list[v.index])
                --end
            end
        end
        --for i,v in ipairs(self.tab_list) do
        --    if v.fun_form_type == data.type then
        --        if v.fun_form_type == PartnerConst.Fun_Form.CrossArenaDef or  -- 跨服竞技场
        --                v.fun_form_type == PartnerConst.Fun_Form.ArenapeakchampionDef then --巅峰冠军赛
        --            self.elfin_team_data_list[v.index] = {}
        --            local old_order
        --            if self.team_data_list[self.select_team_index] then
        --                old_order = self.team_data_list[self.select_team_index].old_order
        --            end
        --            local index_temp = self.team_select_team_index or 1
        --            local cur_index = old_order or (index_temp - 1)
        --
        --            for i,team_data in ipairs(data.team_list) do
        --                self.elfin_team_data_list[v.index][team_data.team + 1] = team_data
        --                if cur_index == team_data.team then
        --                    self:updateElfinList(team_data)
        --                end
        --            end
        --            for i=2,4 do
        --                if self.elfin_team_data_list[v.index][i] == nil then
        --                    self.elfin_team_data_list[v.index][i] = self:getDefaultTeamInfo(i - 1)
        --                end
        --            end
        --        else
        --            self.elfin_team_data_list[v.index] = data.team_list[1]
        --            if self.select_team_index == v.index then
        --                self:updateElfinList(self.elfin_team_data_list[v.index])
        --            end
        --        end
        --        break
        --    end
        --end
    else
        if self.fun_form_type == data.type then
            local temp_data = data.team_list[1]
            if self.fun_form_type == PartnerConst.Fun_Form.CrossArenaDef or
                    self.fun_form_type == PartnerConst.Fun_Form.CrossArena or
                    self.fun_form_type == PartnerConst.Fun_Form.ArenapeakchampionDef then
                --
                ----多队伍 有总览的 需要跳过总览
                --local old_order
                --if self.team_data_list[self.select_team_index] then
                --    old_order = self.team_data_list[self.select_team_index].old_order
                --end
                --local temp_index = old_order or (self.select_team_index - 1)
                --
                --cur_index = temp_index + 1
                --self.elfin_team_data_list = {}
                --for i,v in ipairs(data.team_list) do
                --    self.elfin_team_data_list[v.team + 1]  = v
                --end
                --for i=2,4 do
                --    if self.elfin_team_data_list[i] == nil then
                --        self.elfin_team_data_list[i] = self:getDefaultTeamInfo(i - 1)
                --    end
                --end
            elseif self.fun_form_type == PartnerConst.Fun_Form.HeavenBoss then --天界副本
                ----多队伍没有总览的
                --self.elfin_team_data_list = {}
                --for i,v in ipairs(data.team_list) do
                --    self.elfin_team_data_list[v.team]  = v
                --end
                --for i=1,2 do
                --    if self.elfin_team_data_list[i] == nil then
                --        self.elfin_team_data_list[i] = self:getDefaultTeamInfo(i)
                --    end
                --end
            elseif self.fun_form_type == PartnerConst.Fun_Form.EliteMatch then --段位赛
                --local match_type = self.setting.match_type or ElitematchConst.MatchType.eNormalMatch
                --if match_type == 1 then--段位赛的
                --    self.elfin_team_data_list[1] = data.team_list[1]
                --else--王者赛的
                --    --在下面特殊处理
                --end
            else
                --self.elfin_team_data_list[1] = data.team_list[1]
            end
            ----设置内容
            --for i,v in ipairs(self.tab_list) do
            --    if v.index == cur_index then
            --        self:updateElfinList(self.elfin_team_data_list[cur_index])
            --    end
            --end
            self:updateElfinList(temp_data)
        elseif data.type == PartnerConst.Fun_Form.EliteKingMatch then --王者赛..比较特殊 = =
            --todo
            --local match_type = self.setting.match_type or ElitematchConst.MatchType.eNormalMatch
            --if match_type == 2 then
            --    self.elfin_team_data_list = {}
            --    for i,v in ipairs(data.team_list) do
            --        self.elfin_team_data_list[v.team]  = v
            --    end
            --    for i=1,2 do
            --        if self.elfin_team_data_list[i] == nil then
            --            self.elfin_team_data_list[i] = self:getDefaultTeamInfo(i)
            --        end
            --    end
            --    for i,v in ipairs(self.tab_list) do
            --        if v.index == self.select_team_index then
            --            self:updateElfinList(self.elfin_team_data_list[self.select_team_index])
            --        end
            --    end
            --end
        end
    end
end
-- 更新精灵
function GW_EmbattleWindow:updateElfinList(data)
    if not data then return end
    Debug.info(data)
    self.save_elfin_data = data --保存一下 用于古树信息返回处理用的..
    -- local elfin_bid_list = ElfinController:getInstance():getModel():getElfinTreeElfinList() or {}
    local elfin_bid_list = data.sprites
    local function getElfinBidByPos( pos )
        local elfin_bid
        for k,v in pairs(elfin_bid_list) do
            if v.pos == pos then
                elfin_bid = v.item_bid
                break
            end
        end
        return elfin_bid
    end
    for i=1,4 do
        local elfin_bid = getElfinBidByPos(i)
        local elfin_item = self.elfin_item_list[i]
        --if elfin_item == nil then
        --    elfin_item = SkillItem.new(true, false, true, 0.4)
        --    local pos_x = 24.3
        --    local pos_y = 72.5
        --    if i == 3 or i == 4 then
        --        pos_y = 24.3
        --    end
        --    if i == 2 or i == 4 then
        --        pos_x = 72.5
        --    end
        --    elfin_item:setPosition(cc.p(pos_x, pos_y))
        --    self.elfin_btn:addChild(elfin_item)
        --    self.elfin_item_list[i] = elfin_item
        --end
        local item_bid = ElfinController:getInstance():getModel():getElfinItemByPos(i)
        if item_bid then
            elfin_item.active_icon:setVisible(false)
            local bid = elfin_bid or 0
            --elfin_item:showLockIcon(false)
            local elfin_cfg = Config.SpriteData.data_elfin_data(bid)
            if bid == 0 or not elfin_cfg then -- 已解锁，但未放置精灵
                --elfin_item:setData()
            else
                local skill_cfg = Config.SkillData.data_get_skill(elfin_cfg.skill)
                if skill_cfg then
                    --elfin_item:setData(skill_cfg)
                    local skill_icon = PathTool.getSkillRes(skill_cfg.icon, false)
                    loadSpriteTexture(elfin_item.active_icon, skill_icon, LOADTEXT_TYPE)
                    elfin_item.active_icon:setVisible(true)
                end
            end

            elfin_item.active_info:setVisible(true)
        else
            elfin_item.active_info:setVisible(false)
            --elfin_item:setData()
            --elfin_item:showLockIcon(true)
        end
    end
end

function GW_EmbattleWindow:setPlanSettingInfo(setting)
    if not setting then return end
    --team_list结构参考 26555协议team_list
    local _teamFilterInfo = function(team_list, filter_index)
        local dic_item_id = {}
        for _,v in pairs(team_list) do
            if filter_index ~= v.team then
                if v.sprites and next(v.sprites) ~= nil then
                    for __,sp in ipairs(v.sprites) do
                        if dic_item_id[sp.item_bid] == nil then
                            dic_item_id[sp.item_bid] = 1
                        else
                            dic_item_id[sp.item_bid] = dic_item_id[sp.item_bid] + 1
                        end
                    end
                end
            end
        end
        return dic_item_id
    end

    if self.fun_form_type == PartnerConst.Fun_Form.Drama then
        if self.fun_form_type == PartnerConst.Fun_Form.CrossArenaDef or
                self.fun_form_type == PartnerConst.Fun_Form.ArenapeakchampionDef then
            ---- setting.team_index = self.team_select_team_index - 1
            --
            --setting.team_index  = self.team_data_list[self.select_team_index].old_order
            --if setting.team_index == nil then
            --    setting.team_index = self.team_select_team_index - 1
            --end
            --setting.dic_filter_item_id = _teamFilterInfo(self.elfin_team_data_list[self.select_team_index], setting.team_index)
            --setting.cur_plan_data = self.elfin_team_data_list[self.select_team_index][setting.team_index + 1]
            --setting.total_team_info = self.elfin_team_data_list[self.select_team_index]
        else
            setting.dic_filter_item_id = {}
            --setting.cur_plan_data = self.elfin_team_data_list[self.select_team_index]
            setting.cur_plan_data = self.save_elfin_data
            setting.team_index = 1
        end
    else
        if self.fun_form_type == PartnerConst.Fun_Form.CrossArenaDef or
                self.fun_form_type == PartnerConst.Fun_Form.CrossArena or
                self.fun_form_type == PartnerConst.Fun_Form.ArenapeakchampionDef then
            ----多队伍 有总览的 需要跳过总览
            --setting.team_index  = self.team_data_list[self.select_team_index].old_order
            --if setting.team_index == nil then
            --    setting.team_index = self.select_team_index - 1
            --end
            ---- setting.team_index = self.select_team_index - 1
            --setting.dic_filter_item_id = _teamFilterInfo(self.elfin_team_data_list, setting.team_index)
            --setting.cur_plan_data = self.elfin_team_data_list[setting.team_index + 1]
            --setting.total_team_info = self.elfin_team_data_list
        elseif self.fun_form_type == PartnerConst.Fun_Form.HeavenBoss then
            ----多队伍没有总览的
            --setting.team_index = self.select_team_index
            --setting.dic_filter_item_id = _teamFilterInfo(self.elfin_team_data_list, setting.team_index)
            --setting.cur_plan_data = self.elfin_team_data_list[self.select_team_index]
            --setting.total_team_info = self.elfin_team_data_list
        elseif self.fun_form_type == PartnerConst.Fun_Form.EliteMatch then --段位赛
            --local match_type = self.setting.match_type or ElitematchConst.MatchType.eNormalMatch
            --if match_type == 1 then--段位赛的
            --    setting.dic_filter_item_id = {}
            --    setting.cur_plan_data = self.elfin_team_data_list[self.select_team_index]
            --    setting.team_index = 1
            --else--王者赛的
            --    setting.team_index = self.select_team_index
            --    setting.dic_filter_item_id = _teamFilterInfo(self.elfin_team_data_list, setting.team_index)
            --    setting.cur_plan_data = self.elfin_team_data_list[self.select_team_index]
            --    setting.total_team_info = self.elfin_team_data_list
            --end
            --setting.match_type = match_type
        else
            setting.dic_filter_item_id = {}
            --setting.cur_plan_data = self.elfin_team_data_list[self.select_team_index]
            setting.cur_plan_data = self.save_elfin_data
            setting.team_index = 1
        end
    end
end